#
#  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.
#
#  This file is part of the TerraLib - a Framework for building GIS enabled applications.
#
#  TerraLib is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License,
#  or (at your option) any later version.
#
#  TerraLib is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with TerraLib. See COPYING. If not, write to
#  TerraLib Team at <terralib-team@terralib.org>.
#
#
#  Description: Find Clang tools
#
#  Author: Matheus Cavassan Zaglia
#

FIND_PROGRAM(CLANG_TIDY_EXECUTABLE clang-tidy
                             NAMES clang-tidy-3.6
                                   clang-tidy-3.7
                                   clang-tidy-3.8
                                   clang-tidy-3.9
                                   clang-tidy-4.0
                                   clang-tidy-5.0)

FIND_PROGRAM(CLANG_FORMAT_EXECUTABLE clang-format
                               NAMES clang-format-3.5
                                     clang-format-3.6
                                     clang-format-3.7
                                     clang-format-3.8
                                     clang-format-3.9
                                     clang-format-4.0
                                     clang-format-5.0)

IF(CLANG_TIDY_EXECUTABLE)
    SET(CLANG_TIDY_FOUND TRUE)
    SET(CLANG_TIDY_CHECKS_ENABLED TRUE CACHE BOOL "If true enables clang-tidy checks")
    IF (WIN32)
        STRING(REGEX REPLACE "/" "\\\\" CLANG_TIDY_EXECUTABLE ${CLANG_TIDY_EXECUTABLE})
    ENDIF()
ENDIF()

IF(CLANG_FORMAT_EXECUTABLE)
    SET(CLANG_FORMAT_FOUND TRUE)
    IF(WIN32)
        STRING(REGEX REPLACE "/" "\\\\" CLANG_FORMAT_EXECUTABLE ${CLANG_FORMAT_EXECUTABLE})
    ENDIF()
ENDIF()
