#
#  Copyright (C) 2008-2014 National Institute For Space Research (INPE) - Brazil.
#
#  This file is part of the TerraLib - a Framework for building GIS enabled applications.
#
#  TerraLib is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License,
#  or (at your option) any later version.
#
#  TerraLib is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with TerraLib. See COPYING. If not, write to
#  TerraLib Team at <terralib-team@terralib.org>.
#
#
#  Description: CMake script for the TerraLib build system that describes the TerraLib building.
#
#  Author: Frederico Augusto T. Bede <frederico.bede@funcate.org.br>
#
# ----------------------------------------------------------------------------------------------

# --------------------
# Path configurations
# --------------------
add_definitions(-DTERRALIB_DATA_DIR="${TERRALIB_DATA_DIR}")
add_definitions(-DTERRALIB_REPORT_DIR="${TERRALIB_REPORT_DIR}")
add_definitions(-DTERRALIB_CODEBASE_PATH="${TERRALIB_ABSOLUTE_ROOT_DIR}")
add_definitions(-DTERRALIB_BUILD_PATH="${CMAKE_BINARY_DIR}")
add_definitions(-DTERRALIB_INSTALL_PREFIX_PATH="${CMAKE_INSTALL_PREFIX}")
add_definitions(-DTERRALIB_DIR_VAR_NAME="${TERRALIB_DIR_VAR_NAME}")

if(TERRALIB_GDAL_ENABLED)
    add_definitions(-DTERRALIB_GDAL_DATA="${GDAL_DATA_DIR}")
endif()

if(TERRALIB_MOD_SRS_ENABLED)
    add_definitions(-DTERRALIB_PROJ_LIB="${PROJ4_LIB_DIR}")
endif()

if(TERRALIB_MOD_PYTHON_ENABLED)
  add_definitions(-DTERRALIB_MOD_BINDING_PYTHON_DIR="${TERRALIB_MOD_BINDING_PYTHON_DIR}")
endif()

# ------------------------------
# Module building configurations
# ------------------------------
if(TERRALIB_MOD_ADO_ENABLED)
  add_definitions(-DTERRALIB_MOD_ADO_ENABLED=1)
endif()

if(TERRALIB_MOD_ANNOTATIONTEXT_ENABLED)
  add_definitions(-DTERRALIB_MOD_ANNNOTATIONTEXT_ENABLED=1)
endif()

if(TERRALIB_MOD_CLASSIFICATION_ENABLED)
  add_definitions(-DTERRALIB_MOD_CLASSIFICATION_ENABLED=1)
endif()

if(TERRALIB_MOD_COLOR_ENABLED)
  add_definitions(-DTERRALIB_MOD_COLOR_ENABLED=1)
endif()

if(TERRALIB_MOD_COMMON_ENABLED)
  add_definitions(-DTERRALIB_MOD_COMMON_ENABLED=1)
endif()

if(TERRALIB_MOD_DATAACCESS_ENABLED)
  add_definitions(-DTERRALIB_MOD_DATAACCESS_ENABLED=1)
endif()

if(TERRALIB_MOD_DATATYPE_ENABLED)
  add_definitions(-DTERRALIB_MOD_DATATYPE_ENABLED=1)
endif()

if(TERRALIB_MOD_FILTER_ENABLED)
  add_definitions(-DTERRALIB_MOD_FILTER_ENABLED=1)
endif()

if(TERRALIB_MOD_GDAL_ENABLED)
  add_definitions(-DTERRALIB_MOD_GDAL_ENABLED=1)
endif()

if(TERRALIB_MOD_GEOMETRY_ENABLED)
  add_definitions(-DTERRALIB_MOD_GEOMETRY_ENABLED=1)
endif()

if(TERRALIB_MOD_GML_ENABLED)
  add_definitions(-DTERRALIB_MOD_GML_ENABLED=1)
endif()

if(TERRALIB_MOD_GRAPH_ENABLED)
  add_definitions(-DTERRALIB_MOD_GRAPH_ENABLED=1)
endif()

if(TERRALIB_MOD_LAYOUT_ENABLED)
  add_definitions(-DTERRALIB_MOD_LAYOUT_ENABLED=1)
endif()

if(TERRALIB_MOD_MAPTOOLS_ENABLED)
  add_definitions(-DTERRALIB_MOD_MAPTOOLS_ENABLED=1)
endif()

if(TERRALIB_MOD_MEMORY_ENABLED)
  add_definitions(-DTERRALIB_MOD_MEMORY_ENABLED=1)
endif()

if(TERRALIB_MOD_METADATA_ENABLED)
  add_definitions(-DTERRALIB_MOD_METADATA_ENABLED=1)
endif()

if(TERRALIB_MOD_OGR_ENABLED)
  add_definitions(-DTERRALIB_MOD_OGR_ENABLED=1)
endif()

if(TERRALIB_MOD_PLUGIN_ENABLED)
  add_definitions(-DTERRALIB_MOD_PLUGIN_ENABLED=1)
endif()

if(TERRALIB_MOD_POSTGIS_ENABLED)
  add_definitions(-DTERRALIB_MOD_POSTGIS_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_APF_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_APF_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_ADO_ENABLED)
  add_definitions(-DTERRALIB_MOD_ADO_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_GDAL_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_DATASOURCE_GDAL_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_TERRALIB4_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_DATASOURCE_TERRALIB4_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_OGR_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_DATASOURCE_OGR_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_POSTGIS_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_DATASOURCE_POSTGIS_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_WCS_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_DATASOURCE_WCS_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_WFS_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_DATASOURCE_WFS_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_WMS_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_DATASOURCE_WMS_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_LAYOUT_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_LAYOUT_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_RP_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_RP_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_PLUGINS_VP_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_PLUGINS_VP_ENABLED=1)
endif()

if(TERRALIB_MOD_QT_WIDGETS_ENABLED)
  add_definitions(-DTERRALIB_MOD_QT_WIDGETS_ENABLED=1)
endif()

if(TERRALIB_MOD_RASTER_ENABLED)
  add_definitions(-DTERRALIB_MOD_RASTER_ENABLED=1)
endif()

if(TERRALIB_MOD_RP_ENABLED)
  add_definitions(-DTERRALIB_MOD_RP_ENABLED=1)
endif()

if(TERRALIB_MOD_SAM_ENABLED)
  add_definitions(-DTERRALIB_MOD_SAM_ENABLED=1)
endif()

if(TERRALIB_MOD_SRS_ENABLED)
  add_definitions(-DTERRALIB_MOD_SRS_ENABLED=1)
endif()

if(TERRALIB_MOD_ST_ENABLED)
  add_definitions(-DTERRALIB_MOD_ST_ENABLED=1)
endif()

if(TERRALIB_MOD_STATISTICS_CORE_ENABLED)
  add_definitions(-DTERRALIB_MOD_STATISTICS_CORE_ENABLED=1)
endif()

if(TERRALIB_MOD_STATISTICS_QT_ENABLED)
  add_definitions(-DTERRALIB_MOD_STATISTICS_QT_ENABLED=1)
endif()

if(TERRALIB_MOD_STMEMORY_ENABLED)
  add_definitions(-DTERRALIB_MOD_STMEMORY_ENABLED=1)
endif()

if(TERRALIB_MOD_SYMBOLOGY_ENABLED)
  add_definitions(-DTERRALIB_MOD_SYMBOLOGY_ENABLED=1)
endif()

if(TERRALIB_MOD_TERRALIB4_ENABLED)
  add_definitions(-DTERRALIB_MOD_TERRALIB4_ENABLED=1)
endif()

if(TERRALIB_MOD_VP_CORE_ENABLED)
  add_definitions(-DTERRALIB_MOD_VP_CORE_ENABLED=1)
endif()

if(TERRALIB_MOD_VP_QT_ENABLED)
  add_definitions(-DTERRALIB_MOD_VP_QT_ENABLED=1)
endif()

if(TERRALIB_MOD_XLINK_ENABLED)
  add_definitions(-DTERRALIB_MOD_XLINK_ENABLED=1)
endif()

if(TERRALIB_MOD_XML_ENABLED)
  add_definitions(-DTERRALIB_MOD_XML_ENABLED=1)
endif()

if(TERRALIB_MOD_XSD_ENABLED)
  add_definitions(-DTERRALIB_MOD_XSD_ENABLED=1)
endif()

if(TERRALIB_MOD_WCS_ENABLED)
  add_definitions(-DTERRALIB_MOD_WCS_ENABLED=1)
endif()

if(TERRALIB_MOD_WFS_ENABLED)
  add_definitions(-DTERRALIB_MOD_WFS_ENABLED=1)
endif()

if(TERRALIB_MOD_WMS_CORE_ENABLED)
  add_definitions(-DTERRALIB_MOD_WMS_CORE_ENABLED=1)
endif()

if(TERRALIB_MOD_WMS_QT_ENABLED)
  add_definitions(-DTERRALIB_MOD_WMS_QT_ENABLED=1)
endif()

if(TERRALIB_STATIC_BUILD)
  add_definitions(-DTERRALIB_STATIC_BUILD=1)
endif()

if(TERRALIB_AUTOMATIC_INITIALIZATION)
  add_definitions(-DTERRALIB_AUTOMATIC_INITIALIZATION=1)
endif()

if(TERRALIB_BUILD_AS_BUNDLE)
  add_definitions(-DTERRALIB_BUILD_AS_BUNDLE=1)
endif()

if(TERRALIB_BUILD_AS_DEV)
  add_definitions(-DTERRALIB_BUILD_AS_DEV=1)
endif()

if(TERRALIB_BOOST_ENABLED)
  add_definitions(-DTERRALIB_BOOST_ENABLED=1)
endif()

if(TERRALIB_GDAL_ENABLED)
  add_definitions(-DTERRALIB_GDAL_ENABLED=1)
endif()

if(TERRALIB_GEOS_ENABLED)
  add_definitions(-DTERRALIB_GEOS_ENABLED=1)
endif()

if(TERRALIB_GEOSC_ENABLED)
  add_definitions(-DTERRALIB_GEOSC_ENABLED=1)
endif()

if(TERRALIB_GNU_GETTEXT_ENABLED)
  add_definitions(-DTERRALIB_GNU_GETTEXT_ENABLED=1)
endif()

if(TERRALIB_GNU_ICONV_ENABLED)
  add_definitions(-DTERRALIB_GNU_ICONV_ENABLED=1)
endif()

if(TERRALIB_LIBPQ_ENABLED)
  add_definitions(-DTERRALIB_LIBPQ_ENABLED=1)
endif()

if(TERRALIB_LUA_ENABLED)
  add_definitions(-DTERRALIB_LUA_ENABLED=1)
endif()

if(TERRALIB_PROJ4_ENABLED)
  add_definitions(-DTERRALIB_PROJ4_ENABLED=1)
endif()

if(TERRALIB_QT4_ENABLED)
  add_definitions(-DTERRALIB_QT4_ENABLED=1)
endif()

if(TERRALIB_QT5_ENABLED)
  add_definitions(-DTERRALIB_QT5_ENABLED=1)
endif()

if(TERRALIB_TERRALIB4_ENABLED)
  add_definitions(-DTERRALIB_TERRALIB4_ENABLED=1)
endif()

if(TERRALIB_QT4_ENABLED OR TERRALIB_QT5_ENABLED)
  add_definitions(-DTERRALIB_QT_ENABLED=1)
endif()

if(TERRALIB_QWT_ENABLED)
  add_definitions(-DTERRALIB_QWT_ENABLED=1)
endif()

if(TERRALIB_QTPROPERTYBROWSER_ENABLED)
  add_definitions(-DTERRALIB_QTPROPERTYBROWSER_ENABLED=1)
endif()

if(TERRALIB_SCIDB_ENABLED)
  add_definitions(-DTERRALIB_SCIDB_ENABLED=1)
endif()

if(TERRALIB_SPATIALITE_ENABLED)
  add_definitions(-DTERRALIB_SPATIALITE_ENABLED=1)
endif()

if(TERRALIB_SQLITE_ENABLED)
  add_definitions(-DTERRALIB_SQLITE_ENABLED=1)
endif()

if(TERRALIB_XERCES_ENABLED)
  add_definitions(-DTERRALIB_XERCES_ENABLED=1)
endif()

if(TERRALIB_LOGGER_ENABLED)
  add_definitions(-DTERRALIB_LOGGER_ENABLED=1)
endif()

#Begin logger definitions

if(TERRALIB_LOGGER_ENABLED)

  if(TERRALIB_LOGGER_FATAL_ENABLED)
	add_definitions(-DTERRALIB_LOGGER_FATAL_ENABLED=1)
  else()
	remove_definitions(-DTERRALIB_LOGGER_FATAL_ENABLED=1)
  endif()
  
  if(TERRALIB_LOGGER_ASSERT_ENABLED)
	add_definitions(-DTERRALIB_LOGGER_ASSERT_ENABLED=1)
  else()
	remove_definitions(-DTERRALIB_LOGGER_ASSERT_ENABLED=1)
  endif()
  
  if(TERRALIB_LOGGER_ERROR_ENABLED)
	add_definitions(-DTERRALIB_LOGGER_ERROR_ENABLED=1)
  else()
	remove_definitions(-DTERRALIB_LOGGER_ERROR_ENABLED=1)
  endif()
  
  if(TERRALIB_LOGGER_WARN_ENABLED)
	add_definitions(-DTERRALIB_LOGGER_WARN_ENABLED=1)
  else()
	remove_definitions(-DTERRALIB_LOGGER_WARN_ENABLED=1)
  endif()
  
  if(TERRALIB_LOGGER_INFO_ENABLED)
	add_definitions(-DTERRALIB_LOGGER_INFO_ENABLED=1)
  else()
	remove_definitions(-DTERRALIB_LOGGER_INFO_ENABLED=1)
  endif()
  
  if(TERRALIB_LOGGER_DEBUG_ENABLED)
	add_definitions(-DTERRALIB_LOGGER_DEBUG_ENABLED=1)
  else()
	remove_definitions(-DTERRALIB_LOGGER_DEBUG_ENABLED=1)
  endif()
  
  if(TERRALIB_LOGGER_TRACE_ENABLED)
	add_definitions(-DTERRALIB_LOGGER_TRACE_ENABLED=1)
  else()
	remove_definitions(-DTERRALIB_LOGGER_TRACE_ENABLED=1)
  endif()

endif()

# End logger definitions

if(TERRALIB_TRANSLATOR_ENABLED)
  add_definitions(-DTERRALIB_TRANSLATOR_ENABLED=1)
endif()

if(TERRALIB_MOD_PYTHON_ENABLED)
  add_definitions(-DTERRALIB_MOD_PYTHON_ENABLED=1)
endif()

if(TERRALIB_LEAK_DETECTOR_ENABLED)
  add_definitions(-DTERRALIB_LEAK_DETECTOR_ENABLED=1)
endif()
