#
#  Copyright (C) 2008-2014 National Institute For Space Research (INPE) - Brazil.
#
#  This file is part of the TerraLib - a Framework for building GIS enabled applications.
#
#  TerraLib is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License,
#  or (at your option) any later version.
#
#  TerraLib is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with TerraLib. See COPYING. If not, write to
#  TerraLib Team at <terralib-team@terralib.org>.
#
#
#  Description: TerraLib CMake cache options for building TerraLib on Linux environments. (GitLab Merge Requests).
#

# Defining CMake globals
set(CMAKE_PREFIX_PATH "$ENV{TL_3RDPARTY};$ENV{TL_3RDPARTY};$ENV{TL_3RDPARTY}/pgsql" CACHE PATH "Where to find libraries?" FORCE)
set(CMAKE_INSTALL_PREFIX "$ENV{TL_INSTALL_DIR}" CACHE PATH "Where to install TerraLib?" FORCE)

# Forcing Dependencies Path
set(GDAL_CONFIG      "$ENV{TL_3RDPARTY}/bin/gdal-config" CACHE PATH "Where to find Gdal?" FORCE)
set(GDAL_INCLUDE_DIR "$ENV{TL_3RDPARTY}/include" CACHE PATH "Where to find Gdal2?" FORCE)
set(GDAL_LIBRARY     "$ENV{TL_3RDPARTY}/lib/libgdal.so" CACHE PATH "Where to find Gdal?" FORCE)
set(GDAL_LIBRARY_DIR "$ENV{TL_3RDPARTY}/lib" CACHE PATH "Where to find Gdal?" FORCE)
set(SWIG_EXECUTABLE  "$ENV{TL_3RDPARTY}/bin/swig" CACHE PATH "Where is SWIG?" FORCE)

# Forcing Boost from 3rdparty
set(Boost_INCLUDE_DIR "$ENV{TL_3RDPARTY}/include" CACHE PATH "Where to find Boost?" FORCE)
set(Boost_LIBRARY_DIR_RELEASE  "$ENV{TL_3RDPARTY}/lib" CACHE PATH "Where to find Boost?" FORCE)

# Turning off TerraLib CMake variables:
set(TERRALIB_BUILD_AS_BUNDLE            OFF CACHE BOOL "Build as Bundle?" FORCE)
set(TERRALIB_DOXYGEN_ENABLED            OFF CACHE BOOL "Use Doxygen?" FORCE)

# Turning on TerraLib CMake variables:
set(TERRALIB_BUILD_AS_DEV                ON CACHE BOOL "Build as dev mode?" FORCE)
set(TERRALIB_BUILD_EXAMPLES_ENABLED      ON CACHE BOOL "Build Examples?" FORCE)
set(TERRALIB_BUILD_UNITTEST_ENABLED      ON CACHE BOOL "Build Unittests?" FORCE)
set(TERRALIB_MOD_BINDING_JAVA_ENABLED    ON CACHE BOOL "Build binding Java?" FORCE)
set(TERRALIB_MOD_BINDING_PYTHON_ENABLED  ON CACHE BOOL "Build binding Python?" FORCE)
set(TERRALIB_MOD_BINDING_LUA_ENABLED     ON CACHE BOOL "Build binding Lua?" FORCE)
set(TERRALIB_MOD_MNT_CORE_ENABLED        ON CACHE BOOL "Build MNT Processing Core module?" FORCE)
set(TERRALIB_MOD_CEDITOR_ENABLED         ON CACHE BOOL "Build CEditor?" FORCE)
set(TERRALIB_MOD_EDIT_CORE_ENABLED       ON CACHE BOOL "Build mod Edit?" FORCE)
set(TERRALIB_MOD_QT_PLUGINS_WTSS_ENABLED ON CACHE BOOL "Build mod Wtss-Cxx?" FORCE)
set(TERRALIB_MOD_VM_ENABLED              ON CACHE BOOL "Build Virtual Machine core?" FORCE)
set(TERRALIB_MOD_VM_PYTHON_ENABLED       ON CACHE BOOL "Build Python Virtual Machine?" FORCE)
set(TERRALIB_MOD_VM_LUA_ENABLED          ON CACHE BOOL "Build Lua Virtual Machine?" FORCE)
set(TERRALIB_QHELP_ENABLED               ON CACHE BOOL "Build Qhelp?" FORCE)
set(TERRALIB_QTRANSLATION_ENABLED        ON CACHE BOOL "Build Qtranslations?" FORCE)
set(TERRALIB_TRANSLATOR_ENABLED          ON CACHE BOOL "Build Translator?" FORCE)
