#
#  Copyright (C) 2008-2014 National Institute For Space Research (INPE) - Brazil.
#
#  This file is part of the TerraLib - a Framework for building GIS enabled applications.
#
#  TerraLib is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License,
#  or (at your option) any later version.
#
#  TerraLib is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with TerraLib. See COPYING. If not, write to
#  TerraLib Team at <terralib-team@terralib.org>.
#
#
#  Description: TerraLib CMake cache options for building TerraLib on Windows environments (GitLab Merge Requests).
#
# Force set of install variables:
set(CMAKE_PREFIX_PATH "$ENV{TERRALIB_DEPENDENCIES_DIR};$ENV{TERRALIB_DEPENDENCIES_DIR}/gdal2;$ENV{TERRALIB_DEPENDENCIES_DIR}/pgsql;$ENV{TERRALIB_DEPENDENCIES_DIR}/swig;$ENV{TL_QT5}/lib/cmake/Qt5" CACHE PATH "Where to find libraries?" FORCE)
set(CMAKE_INSTALL_PREFIX "$ENV{TERRALIB_INSTALL_DIR}" CACHE PATH "Where to install TerraLib?" FORCE)
set(terralib4_DIR "$ENV{TERRALIB_DEPENDENCIES_DIR}/lib/cmake/terralib-4.2.2" CACHE PATH "Where to find TerraLib4 libraries?" FORCE)
set (Boost_INCLUDE_DIR "$ENV{TERRALIB_DEPENDENCIES_DIR}/include" CACHE PATH "Where to find Boost?" FORCE)
set (Boost_LIBRARY_DIR_RELEASE "$ENV{TERRALIB_DEPENDENCIES_DIR}/lib" CACHE PATH "Where to find Boost?" FORCE)
set (Boost_PYTHON_LIBRARY_RELEASE "$ENV{TERRALIB_DEPENDENCIES_DIR}/lib/boost_python3-mt.lib" CACHE PATH "boost python" FORCE)
set (Boost_PYTHON_LIBRARY_DEBUG "$ENV{TERRALIB_DEPENDENCIES_DIR}/lib/boost_python3-mt-gd.lib" CACHE PATH "boost python debug" FORCE)

# Turning off TerraLib CMake variables:
set(TERRALIB_DOXYGEN_ENABLED             OFF CACHE BOOL "Use Doxygen?" FORCE)
set(TERRALIB_UNITTEST_WS_CORE_ENABLED    OFF CACHE BOOL "Build OGC WS Unittests?" FORCE)
set(TERRALIB_UNITTEST_WS_OGC_WCS_ENABLED OFF CACHE BOOL "Build OGC WCS unittests?" FORCE)
set(TERRALIB_UNITTEST_WS_OGC_WMS_ENABLED OFF CACHE BOOL "Build OGC WMS unittests?" FORCE)

# Turning on TerraLib CMake variables:
set(TERRALIB_BUILD_AS_DEV                ON CACHE BOOL "Build as dev mode?" FORCE)
set(TERRALIB_BUILD_EXAMPLES_ENABLED      ON CACHE BOOL "Build Examples?" FORCE)
set(TERRALIB_BUILD_UNITTEST_ENABLED      ON CACHE BOOL "Build Unittests?" FORCE)
set(TERRALIB_BUILD_AS_BUNDLE             ON CACHE BOOL "Build As Bundle?" FORCE)
set(TERRALIB_MOD_BINDING_JAVA_ENABLED    OFF CACHE BOOL "Build binding Java?" FORCE)
set(TERRALIB_MOD_BINDING_PYTHON_ENABLED  ON CACHE BOOL "Build binding Python?" FORCE)
set(TERRALIB_MOD_BINDING_LUA_ENABLED     ON CACHE BOOL "Build binding Lua?" FORCE)
set(TERRALIB_MOD_MNT_CORE_ENABLED        ON CACHE BOOL "Build MNT Processing Core module?" FORCE)
set(TERRALIB_MOD_CEDITOR_ENABLED         ON CACHE BOOL "Build CEditor?" FORCE)
set(TERRALIB_MOD_EDIT_CORE_ENABLED       ON CACHE BOOL "Build mod Edit?" FORCE)
set(TERRALIB_MOD_QT_PLUGINS_WTSS_ENABLED ON CACHE BOOL "Build mod Wtss-Cxx?" FORCE)
set(TERRALIB_MOD_VM_ENABLED              ON CACHE BOOL "Build Virtual Machine core?" FORCE)
set(TERRALIB_MOD_VM_PYTHON_ENABLED       ON CACHE BOOL "Build Python Virtual Machine?" FORCE)
set(TERRALIB_MOD_VM_LUA_ENABLED          ON CACHE BOOL "Build Lua Virtual Machine?" FORCE)
set(TERRALIB_QHELP_ENABLED               ON CACHE BOOL "Build Qhelp?" FORCE)
set(TERRALIB_QTRANSLATION_ENABLED        ON CACHE BOOL "Build Qtranslations?" FORCE)
set(TERRALIB_TRANSLATOR_ENABLED          ON CACHE BOOL "Build Translator?" FORCE)
set(TERRALIB_MOD_TERRALIB4_ENABLED       ON CACHE BOOL "Build TerraLib4 support?" FORCE)
set(TERRALIB_MOD_QT_PLUGINS_DATASOURCE_TERRALIB4_ENABLED ON CACHE BOOL "Build Qt TerraLib4 Datasource?" FORCE)
