/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */



import br.inpe.terralib5.DataSource;
import br.inpe.terralib5.Layer;
import br.inpe.terralib5.LayerVector;
import br.inpe.terralib5.QtInitializer;
import br.inpe.terralib5.Str2StrMap;
import br.inpe.terralib5.TerraLib;
import java.awt.Color;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;

/**
 *
 * @author FredBede
 */
public class Exemplo1 {

    static {
        // Loading T5Java dll
        System.loadLibrary("terralib_mod_binding_javad");
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
			
			System.out.println("Java: main 1");
			
            // Initialize TerraLib and Qt.
            QtInitializer qt = new QtInitializer();
			
			System.out.println("Java: main 2");
			
            qt.begin();
			
			System.out.println("Java: main 2");
			
            TerraLib.Initialize();
			
			System.out.println("Java: main 3");
            
            System.out.println("Generating OGR1.png");
            OGRExample1();

            System.out.println("Generating OGR2.png");
            OGRExample2();
            
            System.out.println("Generating PostGIS.png");
            PostGISExample();

            // Finalizing Qt.
            qt.end();
            
            System.out.println("Finished.");
        } catch (IOException ex) {
            Logger.getLogger(Exemplo1.class.getName()).log(Level.SEVERE, null, ex);
        }

        // Finalizing TerraLib
        TerraLib.Finalize();
    } 
    
    protected static void OGRExample1() {
	
		String uri = "file://D:/funcate/data/brazil.shapefiles";
        
        GetLayersAndSaveImage("OGR", uri, "OGR1.png");
    }
    
    protected static void OGRExample2() {
		
		String uri = "file://D:/funcate/vs2010/terralib5/munic_shp";
        
        GetLayersAndSaveImage("OGR", uri, "OGR2.png");
    }

    protected static void PostGISExample() {
		
		String uri = "pgsql://postgres:postgres@localhost:5432/t5_data?PG_CONNECT_TIMEOUT=4";	
        
        GetLayersAndSaveImage("POSTGIS", uri, "PostGIS.png");
    }
    
    protected static void GetLayersAndSaveImage(String type, String uri, String fileName) {
        LayerVector ls = GetLayers(type, uri);
        SaveImage(ls, fileName);
    }
    
    protected static LayerVector GetLayers(String type, String uri) {
        DataSource src = TerraLib.MakeDataSource(type, uri);
        LayerVector ls = null;
        
        if(src != null) 
          ls = TerraLib.GetDataSetsAsLayers(src);
            
        return ls;
    } 
    
    protected static void SaveImage(LayerVector ls, String fileName) {
        long size = 0;
        byte [] img;

        // Getting an image of all layers
        Layer l = ls.get(0);
        img = TerraLib.GetLayersImage(ls, l.getExtent(), 1000, 1000, size, Color.white);

        // Writing image in disk.
        ByteArrayInputStream b = new ByteArrayInputStream(img);
        Image ii;
        try {
            ii = ImageIO.read(b);
            BufferedImage bi = new BufferedImage(1000, 1000, BufferedImage.TYPE_INT_RGB);
            bi.createGraphics().drawImage(ii, 0, 0, null);
            File out = new File(fileName);
            ImageIO.write(bi, "png", out);
        } catch (IOException ex) {
            Logger.getLogger(Exemplo1.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
