from terralib import raster, rp, core, common
import glob, os

# Path with raster layers
raster_dir = glob.glob('.../data/geotiff/*.tif')

# Creating raster array
rasters = []

for raster_file_path in raster_dir:
  # Getting only file name with extension
  current_file = os.path.basename(raster_file_path)
  layer_raster = raster.open(raster_file_path)

  rasters.append(layer_raster)

# URI protocol: file://+path+filename
uri_output_layer = core.URI('file:///.../output/composed_'+current_file)

rp.SimpleComposeBandsFromURI(rasters, uri_output_layer)
print('Composition ended successfully!')