from terralib import raster, rp, core

# Raster layer path
raster_layer = raster.open('.../geotiff/cbers_rgb342_crop1.tif')

# URI protocol: file://+path+filename
uri_ipca_output_layer = core.URI('file:///.../outputdata/mixturepca.tif')
uri_linear_output_layer = core.URI('file:///.../outputdata/mixturelinear.tif')

rp.SimpleMixtureModelPCAFromURI(raster_layer, 
			         uri_ipca_output_layer,
			         range(0,3),
				 {'clouds':[38, 38, 76], 'shadow':[165, 255, 255], 'vegetation':[42, 166, 74]})

print('Mixture Model PCA ended successfully!')


rp.SimpleMixtureModelLinearFromURI(raster_layer,
				     uri_linear_output_layer,
				     range(0,3),
				     {'clouds':[38, 38, 76], 'shadow':[165, 255, 255], 'vegetation':[42, 166, 74]})

print('Mixture Model Linear ended successfully!')