from terralib import raster, rp, core, common
import glob, os

# Path with raster layers
raster_dir = glob.glob('.../data/geotiff/*.tif')

for raster_file_path in raster_dir:
	# Getting only file name with extension
	current_file = os.path.basename(raster_file_path)
	layer_raster = raster.open(raster_file_path)

	# URI protocol: file://+path+filename
	uri_ipca_output_layer = core.URI('file:///.../outputdata/mixturepca_'+current_file)
	uri_linear_output_layer = core.URI('file:///.../outputdata/mixturelinear_'+current_file)

	try:
		rp.SimpleMixtureModelPCAFromURI(raster_layer, 
									  uri_ipca_output_layer,
									  range(0,3),
									 {'clouds':[38, 38, 76], 'shadow':[165, 255, 255], 'vegetation':[42, 166, 74]})

		print('Mixture Model PCA ended successfully!')


		rp.SimpleMixtureModelLinearFromURI(raster_layer,
									     uri_linear_output_layer,
									     range(0,3),
									     {'clouds':[38, 38, 76], 'shadow':[165, 255, 255], 'vegetation':[42, 166, 74]})

		print('Mixture Model Linear ended successfully!')

	except Exception as e:
		print(e)
		print(uri_ipca_output_layer.path())
		print(uri_linear_output_layer.path())