from terralib import raster, rp, core

# Raster layer path
raster_layer = raster.open('.../data/geotiff/cbers_rgb342_crop2.tif')

# URI protocol: file://+path+filename
uri_mean = core.URI('file:///.../outputdata/mean.tif')
uri_baatz = core.URI('file:///.../outputdata/baatz.tif')

rp.SegmenterRegionGrowingMeanFromURI(raster_layer, range(raster_layer.getNumberOfBands()), uri_mean, minSegmentSize=100, segmentsSimilarityThreshold=0.1)
print('Segmenter by region growing mean ended successfully!')
rp.SegmenterRegionGrowingBaatzFromURI(raster_layer, [0,1], uri_baatz, bandsWeights=[0.5, 0.5], segmentsSimilarityThreshold=0.5, colorWeight=0.9, compactnessWeight=0.5)
print('Segmenter by region growing baatz ended successfully!')
