from terralib import raster, rp, core

# Raster layer path
raster_layer = raster.open('.../data/geotiff/cbers_rgb342_crop2.tif')

# URI protocol: file://+path+filename
uri_mean = core.URI('file:///.../outputdata/mean.tif')
uri_baatz = core.URI('file:///.../outputdata/baatz.tif')

# Trying to segmenting layers with Mean and Baatz
try:
	# Simplest signature: SegmenterRegionGrowingMean(layer_raster, uri)
	rp.SimpleSegmenterRegionGrowingMeanFromURI(raster_layer, uri_mean)
	print('Segmenter by region growing mean ended successfully!')

	# Simplest signature: SegmenterRegionGrowingBaatz(layer_raster, uri)
	rp.SimpleSegmenterRegionGrowingBaatzFromURI(raster_layer, uri_baatz)
	print('Segmenter by region growing baatz ended successfully!')

except Exception as e:
	print(e)
	print(uri_mean.path())
	print(uri_baatz.path())