from terralib import raster, rp, core

# URI parameters - Changing user/password/host/port/database/schema/table to yours respective connection parameters
uri_bd = core.URI('PG://user:password@host:port/database?schema=schemaname&table=tablename&mode=2')

# Creating the datasource GDAL with bd uri
data_source = dataaccess.DataSourceFactory.make('GDAL', uri_bd)

# Opening the datasource
data_source.open()

# Getting the dataset names list
dataset_names_list = data_source.getDataSetNames()

# Getting the first one dataset name from the list
data_set = data_source.getDataSet(dataset_names_list[0])

# The enum RASTER_TYPE = 22
raster_pos = dataaccess.GetFirstPropertyPos(data_set, 22)

# Getting raster layer from the dataset
layer_raster = data_set.getRaster(raster_pos)

# URI protocol: file://+path+filename
uri_output_layer = core.URI('file:///.../output/water.tif')

rp.SimpleThresholdFromURI(layer_raster, uri_output_layer)
print('Threshold ended successfully!')