// Examples
#include "GraphExamples.h"

// TerraLib
#include <terralib/common/progress/ProgressManager.h>
#include <terralib/common/progress/ConsoleProgressViewer.h>
#include <terralib/common/TerraLib.h>
#include <terralib/core/plugin.h>


// STL
#include <cstdlib>
#include <iostream>
#include <locale>


int main()
{
  setlocale(LC_ALL,"C");

  try
  {
    //startup terralib
    TerraLib::getInstance().initialize();
    
    //create a progress bar
    std::unique_ptr<te::common::ConsoleProgressViewer> cpv(new te::common::ConsoleProgressViewer());

    //load all necessary modules
    LoadModules();

    //-----------------------------------------------------------------------------------------------------
    bool draw = true;

    //create ldd graph
    CreateMSTGraph(draw);

    //-----------------------------------------------------------------------------------------------------

    //unload modules
    te::core::PluginManager::instance().clear();
    
    //finalize terralib
    TerraLib::getInstance().finalize();
  }
  catch(const std::exception& e)
  {
    std::cout << std::endl << "An exception has occurred in the Graph examples: " << e.what() << std::endl;

    return EXIT_FAILURE;
  }
  catch(...)
  {
    std::cout << std::endl << "An unexpected exception has occurred in the Graph examples!" << std::endl;

    return EXIT_FAILURE;
  }

  return EXIT_SUCCESS;
}
