#include "gtest/gtest.h"

//Terralib include files
#include <terralib/common/TerraLib.h>
#include <terralib/core/plugin.h>
#include <terralib/core/utils/Platform.h>


// TerraLib
#include <terralib_buildconfig.h>

#include "TestUtils.h"

class TerralibTestEnvironment : public ::testing::Environment 
{
public:

	TerralibTestEnvironment()
	{

	}

	// Override this to define how to set up the environment.
	virtual void SetUp() 
	{
    TerraLib::getInstance().initialize();
    loadTL5Modules();
	}

	// Override this to define how to tear down the environment.
	virtual void TearDown() 
	{
    te::core::PluginManager::instance().clear();
    TerraLib::getInstance().finalize();
	}

  virtual void loadTL5Modules()
  {
    std::vector<std::string> vecPluginsToLoad;
    vecPluginsToLoad.push_back("te.da.ogr.teplg.json");

    std::string plugins_path = te::core::FindInTerraLibPath("share/terralib/plugins");
    for (std::size_t i = 0; i < vecPluginsToLoad.size(); ++i)
    {
      const std::string& pluginFileName = vecPluginsToLoad.at(i);

      te::core::PluginInfo info = te::core::JSONPluginInfoSerializer(plugins_path + "/" + pluginFileName);
      if (te::core::PluginManager::instance().isLoaded(info.name) == true)
      {
        continue;
      }

      te::core::PluginManager::instance().insert(info);
      te::core::PluginManager::instance().load(info.name);
    }
  }
};
