﻿/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/itest/raster/main.cpp

  \brief Main file of integration tests for the VP module.

  \author Eric Silva Abreu
 */

//Tests include files
#include "TerralibTestEnvironment.h"

#include <terralib_buildconfig.h>

// GTest and GMock
#include <gmock/gmock.h>
#include <gtest/gtest.h>

#ifdef TERRALIB_LEAK_DETECTOR_ENABLED
#include <vld.h>
#endif

int main(int argc, char** argv) {

  ::testing::InitGoogleMock(&argc, argv);
  ::testing::AddGlobalTestEnvironment(new TerralibTestEnvironment());

  ::testing::GTEST_FLAG(filter) = "*.*";

  return RUN_ALL_TESTS();
}
