# Debian package instructions (Linux)

First of all make sure that we support your version of Ubuntu:
* Ubuntu 14.04 LTS
* Ubuntu 16.04 LTS

---

## Automatic generation:

Execute the ``configure.sh`` script to create the ``build-all.sh`` file with the correct TerraLib version, example:

```shell
 $ ./configure.sh
```

To execute all the commands and scripts to generate the debian packages, simply execute the ``build-all.sh``.

Which automatically:
* Installs third-party libraries;
* Generates and installs third-party library packages;
* Generates and installs the TerraLib package;
* Copies all necessary files to an output folder (``3rdparty``) next to your codebase;
* Compacts all in the final file ``terralib-<terralib_version>-ubuntu-<ubuntu_version>.tar.gz``.

_Obs .: Don't forget to add the source of each library to the same directory as the scripts._

If necessary you can manually execute the scripts. Be sure to check if the variables set by default are correct in all scripts according to your environment.

---

## Third-party Libraries Packages:

To generate the debian packages from libraries that are not on the system or that must be configured specifically for TerraLib, simply execute the ``deb-<library_name>.sh`` script from each library, where the source of the library must be in the same directory as the script.

The script automatically:
* Extracts the library package (if the source is in the same directory as the script);
* Creates the ``debian`` folder with the package settings;
* Generates the library package;
* Moves the package to an output directory (``3rdparty``) next to your codebase;
* Removes any unnecessary files that were left in your codebase.

To add a new library, you can create a new shell script based on existing ones and modify the fields according to the new library.
Check the creation of the ``rules`` file that contains the commands to configure, compile and install the library. Then update the ``build-all.sh`` and ``install-generator.sh`` scripts.

---

## TerraLib Package:

To generate the TerraLib debian package first verify if all dependencies have been installed correctly. Then simply execute the ``deb-terralib.sh`` script.

Which automatically:
* Creates a ``build-package`` folder;
* Configures CMake properly;
* Generates the TerraLib package;

---

## Final Package:

The ``install-generator.sh`` script creates the following files:
* Install script;
* Uninstall script;
* Info file about the package (README).

_Obs.: Before execute the script check the default variables with the versions of the libraries._

To generate the final package, simply compress the following files into a ``tar.gz``:
* Debian packages of dependencies and TerraLib in ``packages`` folder;
* Scripts ``install.sh``, ``uninstall.sh`` and``README`` file outside the packages folder.
