#!/bin/bash
#
#  Copyright (C) 2008-2014 National Institute For Space Research (INPE) - Brazil.
#
#  This file is part of the TerraLib - a Framework for building GIS enabled applications.
#
#  TerraLib is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License,
#  or (at your option) any later version.
#
#  TerraLib is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with TerraLib. See COPYING. If not, write to
#  TerraLib Team at <terralib-team@terralib.org>.
#
#
#  Description: Prepares TerraAmazon environment for compilation.
#               Once done, you may run "deb-terraamazon.sh" to proceed.
# 
#  Before start, please read the "PACKAGE-INSTRUCTIONS".
# 
#  Usage: cd /path/to/git/packages/linux/configure.sh
#

if [ -z "$CODEBASE" ]; then
  export CODEBASE=`pwd`/../..
fi

if [ -z "$TE_BUILD_DIR" ]; then
  export TE_BUILD_DIR=${CODEBASE}/../build-package
fi

rm -rf $TE_BUILD_DIR
mkdir -p $TE_BUILD_DIR

cd $TE_BUILD_DIR

cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE="Release" \
                          -DTERRALIB_BUILD_ON_CI_SERVER:BOOL=ON \
                          ${CODEBASE}/build/cmake