#
#  Copyright (C) 2008-2014 National Institute For Space Research (INPE) - Brazil.
#
#  This file is part of the TerraLib - a Framework for building GIS enabled applications.
#
#  TerraLib is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License,
#  or (at your option) any later version.
#
#  TerraLib is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with TerraLib. See COPYING. If not, write to
#  TerraLib Team at <terralib-team@terralib.org>.
#
#  Description: TerraLib CMake cache options for building TerraLib on Linux environments.
#
#  Before start, please read the "PACKAGE-INSTRUCTIONS".
#

# Define CMake variables:
set (CMAKE_INSTALL_PREFIX "$ENV{TE_INSTALL}/" CACHE PATH "Where to install TerraLib?" FORCE)
set (CMAKE_INSTALL_RPATH "$ENV{TE_INSTALL}/lib" CACHE PATH "Where to install TerraLib libs?" FORCE)
set (CMAKE_PREFIX_PATH "/usr;$ENV{TE_INSTALL}/3rdparty;$ENV{TE_INSTALL}/3rdparty/lib" CACHE PATH "Where to find libraries?" FORCE)
set (CMAKE_SKIP_BUILD_RPATH OFF CACHE BOOL "Skip build rpath?" FORCE)
set (CMAKE_BUILD_WITH_INSTALL_RPATH OFF CACHE BOOL "Build with install rpath?" FORCE)
set (CMAKE_INSTALL_RPATH_USE_LINK_PATH ON CACHE BOOL "Rpath use link path?" FORCE)

# Set Gdal path:
set (GDAL_CONFIG "$ENV{TE_INSTALL}/3rdparty/bin/gdal-config" CACHE PATH "Where to find Gdal2 config?" FORCE)
set (GDAL_INCLUDE_DIR "$ENV{TE_INSTALL}/3rdparty/include" CACHE PATH "Where to find Gdal2 include?" FORCE)
set (GDAL_LIBRARY "$ENV{TE_INSTALL}/3rdparty/lib/libgdal.so" CACHE PATH "Where to find Gdal2 lib file?" FORCE)
set (GDAL_LIBRARY_DIR "$ENV{TE_INSTALL}/3rdparty/lib" CACHE PATH "Where to find Gdal2 lib dir?" FORCE)
set (Boost_INCLUDE_DIR "$ENV{TE_INSTALL}/3rdparty/include" CACHE PATH "Where to find Gdal include?" FORCE)
set (SWIG_EXECUTABLE "/usr/bin/swig3.0" CACHE FILEPATH "Where to find swig.exe?" FORCE)

# Turn off TerraLib CMake variables:
set (TERRALIB_DOXYGEN_ENABLED OFF CACHE BOOL "Use Doxygen?" FORCE)
set (TERRALIB_BUILD_EXAMPLES_ENABLED OFF CACHE BOOL "Build Examples?" FORCE)
set (TERRALIB_BUILD_UNITTEST_ENABLED OFF CACHE BOOL "Build Unittests?" FORCE)
set (TERRALIB_MOD_BINDING_LUA_ENABLED OFF CACHE BOOL "Build binding Lua?" FORCE)
set (TERRALIB_MOD_BINDING_JAVA_ENABLED OFF CACHE BOOL "Build binding Java?" FORCE)

# Turn on TerraLib CMake variables:
set (TERRALIB_BUILD_AS_BUNDLE ON CACHE BOOL "Build As Bundle?" FORCE)
set (TERRALIB_MOD_BINDING_PYTHON_ENABLED ON CACHE BOOL "Build binding Python?" FORCE)
set (TERRALIB_MOD_CEDITOR_ENABLED ON CACHE BOOL "Build Code Editor plugin?" FORCE)
set (TERRALIB_MOD_EDIT_CORE_ENABLED ON CACHE BOOL "Build Edit?" FORCE)
set (TERRALIB_MOD_QT_PLUGINS_WTSS_ENABLED ON CACHE BOOL "Build Wtss-Cxx?" FORCE)
set (TERRALIB_MOD_VM_ENABLED ON CACHE BOOL "Build Virtual Machine module?" FORCE)
set (TERRALIB_MOD_VM_PYTHON_ENABLED ON CACHE BOOL "Build Python Virtual Machine plugin?" FORCE)
set (TERRALIB_MOD_VM_LUA_ENABLED ON CACHE BOOL "Build VM lua?" FORCE)
set (TERRALIB_QHELP_ENABLED ON CACHE BOOL "Build Qhelp?" FORCE)
set (TERRALIB_QTRANSLATION_ENABLED ON CACHE BOOL "Build Qtranslations?" FORCE)
set (TERRALIB_TRANSLATOR_ENABLED ON CACHE BOOL "Build Translator?" FORCE)

# Set the package type to be generated:
set (CPACK_BINARY_DEB ON CACHE BOOL "Generate DEB?" FORCE)
set (CPACK_BINARY_STGZ OFF CACHE BOOL "Generate STGZ?" FORCE)
set (CPACK_BINARY_TGZ OFF CACHE BOOL "Generate TGZ?" FORCE)
set (CPACK_BINARY_TZ OFF CACHE BOOL "Generate TZ?" FORCE)
set (CPACK_SOURCE_TBZ2 OFF CACHE BOOL "Generate TBZ2 Source?" FORCE)
set (CPACK_SOURCE_TGZ OFF CACHE BOOL "Generate TGZ  Source?" FORCE)
set (CPACK_SOURCE_TZ OFF CACHE BOOL "Generate TZ Source?" FORCE)
