::
:: Before start, please read the "PACKAGE-INSTRUCTIONS"
:: file located in packages/windows folder.
::

:: Turn off system messages
@echo off
:: Clear screen
cls;
:: Welcome message
echo.
echo **************************************************
echo * TerraLib Package Installer for Windows 64-bits *
echo **************************************************
echo.
:: ====

:: Where is script file
set "ROOT_DIR=%CD%"

:: TerraLib Paths
set "TERRALIB_DEPENDENCIES_DIR=C:\terralib5-3rdparty-msvc-2015-win64"
set "TERRALIB_CODEBASE_PATH=%ROOT_DIR%\..\.."
set "TERRALIB_BUILD_PATH=%TERRALIB_CODEBASE_PATH%\..\build-package"
set "TERRALIB_INSTALL_PATH=%TERRALIB_DEPENDENCIES_DIR%\terralib-install"
set "TERRAPRINT_DIR=%TERRALIB_DEPENDENCIES_DIR%\terraprint-install\lib\cmake\terralib_layout-1.1.0"

:: Where is qmake.exe
set "QMAKE_FILEPATH=C:\Qt\Qt5.8.0\5.8\msvc2015_64\bin"
:: Where is Visual Studio
set "VCVARS_FILEPATH=%PROGRAMFILES(x86)%\Microsoft Visual Studio 14.0\VC"
:: Where is cmake.exe
set "CMAKE_FILEPATH=%PROGRAMFILES(x86)%\CMake\bin"

:: Environment Paths
set "PATH=%CMAKE_FILEPATH%;%QMAKE_FILEPATH%;%PATH%"
:: Build Type
set "BUILD_TYPE=PACKAGE"

::  Setting visual studio environment
::  ==================================

set _CMAKE_GENERATOR="Visual Studio 14 2015 Win64"
set _config=x64

echo | set /p="Configuring visual studio... "<nul

call "%VCVARS_FILEPATH%"\vcvarsall.bat %_config%

echo done.
echo.

::  Creating and configuring build folder
::  ======================================

echo | set /p="Configuring build folder... "<nul

IF NOT EXIST %TERRALIB_BUILD_PATH% (
  mkdir %TERRALIB_BUILD_PATH% >nul 2>nul
)

xcopy %TERRALIB_CODEBASE_PATH%\packages\windows\terralib.conf.cmake %TERRALIB_BUILD_PATH% /S /Y >nul 2>nul

echo done.
echo.

IF EXIST %TERRALIB_BUILD_PATH% (
  cd /d %TERRALIB_BUILD_PATH% >nul 2>nul
)

::  Configuring CMake and generating files
::  =======================================

echo | set /p="Configuring CMake... "<nul

cmake -G %_CMAKE_GENERATOR% -C ./terralib.conf.cmake -DCMAKE_BUILD_TYPE="Release" %TERRALIB_CODEBASE_PATH%\build\cmake

echo done.
echo.

::  Building VS2013 all Project
::  ============================

echo | set /p="Building project... "<nul

msbuild /m /t:clean ALL_BUILD.vcxproj /p:Configuration=Release

msbuild /m ALL_BUILD.vcxproj /p:Configuration=Release

echo done.
echo.

::  Installing TerraLib in dependencies dir
::  ========================================

echo | set /p="Installing... "<nul

msbuild /m INSTALL.vcxproj /p:Configuration=Release

echo done.
echo.

::  Generating TerraLib NSIS package
::  =================================

echo | set /p="Packaging... "<nul

msbuild /m PACKAGE.vcxproj /p:Configuration=Release
set _BUILD_STATUS=%errorlevel%

echo done.
echo.

:: ====

echo.
echo.
echo ************************************************************
echo * TerraLib Package Installer for Windows 64-bits finished! *
echo ************************************************************
echo Finished!
echo.

exit /b %_BUILD_STATUS%
