/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file NoExceptDefinition.h

  \brief Definitions required by VS version lesser then 2015 to work using noexcept reserved work. 
 */

#ifndef __TERRALIB_INTERNAL_NOEXCEPTDEFINITION_H
#define __TERRALIB_INTERNAL_NOEXCEPTDEFINITION_H

#ifdef _MSC_VER
  #if _MSC_VER <= 1900
    #include <yvals.h>
  #else
    #define _NOEXCEPT_OP(x) noexcept(x) 
  #endif
#else
  #define _NOEXCEPT_OP(x) noexcept(x)
#endif

#endif  // __TERRALIB_INTERNAL_NOEXCEPTDEFINITION_H
