/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled
  applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
*/

#ifndef __TERRALIB_BINDING_C_CTYPES_H__
#define __TERRALIB_BINDING_C_CTYPES_H__

#ifdef __cplusplus
extern "C" {
#endif
\
//DataType
#ifndef TeAbstractData
typedef struct TeAbstractData_t TeAbstractData;
#endif

//DataAccess
#ifndef TeDataSet
typedef struct TeDataset_t TeDataSet;
#endif
#ifndef TeDataSetItem
typedef struct TeDataSetItem_t TeDataSetItem;
#endif
#ifndef TeDataSource
typedef struct TeDataSource_t TeDataSource;
#endif
#ifndef TeDataSourceTransactor
typedef struct TeDataSourceTransactor_t TeDataSourceTransactor;
#endif

//Geometry

#ifndef TeCoord2D
typedef struct TeCoord2D_t TeCoord2D;
#endif
#ifndef TeEnvelop
typedef struct TeEnvelop_t TeEnvelop;
#endif


//Raster
#ifndef TeBand
typedef struct TeBand_t TeBand;
#endif
#ifndef TeBandProperty
typedef struct TeBandProperty_t TeBandProperty;
#endif
#ifndef TeGrid
typedef struct TeGrid_t TeGrid;
#endif
#ifndef TeRaster
typedef struct TeRaster_t TeRaster;
#endif

// te::rst::Bands

#ifdef __cplusplus
}  // extern "C"
#endif

#endif  //__TERRALIB_BINDING_C_CPPTYPES_H__
