/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled
  applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
*/

#define TE_FALSE  0
#define TE_TRUE   1
#define TE_ERROR -1
#define TE_OK    -2

#ifdef WIN32
  #ifdef TECAPISTATIC
    #define TECAPIEXPORT                          /* Don't need to export/import... it is a static library */
  #elif TECAPIDLL
    #define TECAPIEXPORT  __declspec(dllexport)   /* export DLL information */
  #else
    #define TECAPIEXPORT  __declspec(dllimport)   /* import DLL information */
  #endif 
#else
  #define TECAPIEXPORT
#endif
