/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled
  applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
*/

#ifndef __TERRALIB_BINDING_C_CPPTYPES_H__
#define __TERRALIB_BINDING_C_CPPTYPES_H__

//DataType
#define TeAbstractData te::dt::AbstractData

//Dataaccess
#define TeDataSet te::da::DataSet
#define TeDataSetItem te::da::DataSetItem
#define TeDataSource te::da::DataSource
#define TeDataSourceTransactor te::da::DataSourceTransactor

//Geometry
#define TeCoord2D te::gm::Coord2D
#define TeEnvelop te::gm::Envelop

//Raster
#define TeBand te::rst::Band
#define TeBandProperty te::rst::BandProperty
#define TeGrid te::rst::Grid
#define TeRaster te::rst::Raster

#endif //__TERRALIB_BINDING_C_CORE_CPPTYPES_H__
