/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled
  applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
*/

// TerraLib
#include "terralib/raster/Raster.h"
#include "terralib/raster/RasterFactory.h"

#include "../CppTypes.h"  // DO NOT CHANGE THE ORDER
#include "CRaster.h"

// STL
#include <iostream>
#include <cassert>
extern "C" {

TeRaster* TeOpenRaster(const char* path)
{
  return te::rst::RasterFactory::open("URI", path);
}

const char* TeRasterToString(const TeRaster* rst)
{
  assert(rst);
  char* str = new char[rst->toString().size() + 1];
  strcpy(str, rst->toString().c_str());
  return str;
}

void TeDestroyRaster(TeRaster* rst)
{
  delete rst;
}

const TeBand* TeRasterGetBand(const TeRaster* rst, int band)
{
  assert(rst);
  return rst->getBand(band);
}
}
