/*
 * File: CellSpace.i
 *
 * Cellular Space module specific to Lua
 */

%extend te::cellspace::CellularSpacesOperations {
  std::string createCellSpace(te::da::DataSourceInfo outputSource,
					   const std::string& name,
		  		       double resX,
					   double resY,
			           const te::gm::Envelope& env,
	                   int srid,
					   te::cellspace::CellularSpacesOperations::CellSpaceType type,
					   te::map::AbstractLayer* layerBase)
  {
	te::da::DataSourceInfoPtr ds;
    ds.reset(new te::da::DataSourceInfo);
	*ds = outputSource;
    te::map::AbstractLayerPtr layer(layerBase->clone());

    try
	{
      $self->createCellSpace(ds, name, resX, resY, env, srid, type, layer);
    }
    catch(const te::da::Exception& e)
    {
      return e.what();
    }

	ds.reset();

	return "";
  }

  std::string createCellSpace(te::da::DataSourceInfo outputSource,
					   const std::string& name,
		  		       double resX,
					   double resY,
			           const te::gm::Envelope& env,
	                   int srid,
					   te::cellspace::CellularSpacesOperations::CellSpaceType type)
  {
	te::da::DataSourceInfoPtr ds;
    ds.reset(new te::da::DataSourceInfo);
	*ds = outputSource;
    te::map::AbstractLayerPtr layer;

    try
    {
      $self->createCellSpace(ds, name, resX, resY, env, srid, type, layer);
    }
    catch(const te::da::Exception& e)
    {
      return e.what();
    }

	ds.reset();

	return "";
  }
};
