/*
 * File: Common.i
 *
 * Common module especific to Lua
 */

%{
#ifndef __TERRALIB_COMMON_LUA_PROGRESS_VIEWER_H
#define __TERRALIB_COMMON_LUA_PROGRESS_VIEWER_H

#include <iostream>
#include "terralib/common/progress/TaskProgress.h"

namespace te
{
  namespace common
  {
    class TaskProgress;

    class LuaProgressViewer : public ConsoleProgressViewer
    {
      public:
        LuaProgressViewer() : ConsoleProgressViewer() {}

        ~LuaProgressViewer() {}

        void addTask(TaskProgress* t, int id)
		{
          ConsoleProgressViewer::addTask(t, id);
        }

        void removeTask(int taskId)
        {
          ConsoleProgressViewer::removeTask(taskId);
        }

        void cancelTask(int taskId)
        {
          ConsoleProgressViewer::cancelTask(taskId);
        }

        void setTotalValues(int taskId)
        {
		  ConsoleProgressViewer::setTotalValues(taskId);
        }

        void updateValue(int taskId)
        {
          int pv = m_tasks.at(taskId)->getProportionalValue();
		  if (m_propStep == 100)
		  {
            int msgSize = m_message.size() + 6;
            std::cout << "\r" << std::string(msgSize, ' ');
			std::cout << "\r" << std::flush;
			m_propStep = 999;
		  }
          else if((pv > m_propStep) && (m_propStep <= 100))
          {
            std::cout << "\r" << m_message << " " << pv << "%";
            m_propStep = pv;
          }
        }

        void updateMessage(int taskId){}

		void setMessage(const std::string& msg)
        {
          m_message = msg;
        }
    };

  } // end namespace common
} // end namespace te

#endif //__TERRALIB_COMMON_LUA_PROGRESS_VIEWER_H
%}

%nspace te::common::LuaProgressViewer;

namespace te
{
  namespace common
  {
    class TaskProgress;

    class LuaProgressViewer : public ConsoleProgressViewer
    {
      public:
        LuaProgressViewer();
        ~LuaProgressViewer();
		void setMessage(const std::string& msg);
    };
  } // end namespace common
} // end namespace te
