%{
  void SaveRasterOnFile(const te::rst::Raster* raster, const std::string filePath,
                                      unsigned int srid = 0)
  {
    std::vector<te::rst::BandProperty*> bandsProperties;
    for (int b = 0; b < raster->getNumberOfBands(); b++)
    {
      bandsProperties.push_back(new te::rst::BandProperty(*(raster->getBand(b)->getProperty())));
    }

	std::unique_ptr<te::rst::Grid> grid;
	grid = std::unique_ptr<te::rst::Grid>(new te::rst::Grid(*(raster->getGrid())));

	if(srid > 0)
    {
	  grid->setSRID(srid);
	}

    te::rp::RasterHandler outRasterHandler;
    te::rp::CreateNewGdalRaster(*grid, bandsProperties, filePath, outRasterHandler);
	te::rst::Raster* outRaster(outRasterHandler.getRasterPtr());

    int rows = raster->getNumberOfRows();
    int columns = raster->getNumberOfColumns();
    int bands = (int)bandsProperties.size();

    for(int b = 0; b < bands; b++)
    {
	  outRaster->getBand(b)->getProperty()->m_noDataValue = bandsProperties.at(b)->m_noDataValue;

	  for(int row = 0; row < rows; row++)
	  {
	    for(int col = 0; col < columns; col++)
	    {
		  double value;
		  raster->getBand(b)->getValue(col, row, value);
		  outRaster->setValue(col, row, value, b);
	    }
	  }
    }
  }

  void CreateRasterOnFile(const te::rst::Raster* raster, const std::string filePath,
                          te::rp::RasterHandler& outRasterHandler, double dummy = 0)
  {
    std::vector<te::rst::BandProperty*> bandsProperties;
    for (int b = 0; b < raster->getNumberOfBands(); b++)
    {
      bandsProperties.push_back(new te::rst::BandProperty(*(raster->getBand(b)->getProperty())));
	  if(dummy > 0)
	  {
	    bandsProperties.at(b)->m_noDataValue = dummy;
	  }
    }

	std::unique_ptr<te::rst::Grid> grid;
	grid = std::unique_ptr<te::rst::Grid>(new te::rst::Grid(*(raster->getGrid())));

    te::rp::CreateNewGdalRaster(*grid, bandsProperties, filePath, outRasterHandler);
  }
%}

void SaveRasterOnFile(const te::rst::Raster* raster, const std::string filePath, unsigned int srid = 0);
void CreateRasterOnFile(const te::rst::Raster* raster, const std::string filePath,
                        te::rp::RasterHandler& outRasterHandler, double dummy = 0);