#define TEDATAACCESSEXPORT

%include Config.i
%module(package="terralib") dataaccess


%import "terralib/common/Singleton.h"

namespace te {
  namespace common {
    %template(DataSourceManagerSingleton) Singleton < te::da::DataSourceManager >;
    %template(DataSourceInfoManagerSingleton) Singleton < te::da::DataSourceInfoManager >;
  }
}

%ignore te::da::GetDataSource;

typedef te::common::Singleton< te::da::DataSourceManager > DataSourceManagerSingleton;
typedef te::common::Singleton< te::da::DataSourceInfoManager > DataSourceInfoManagerSingleton;

%{
#include "terralib/dataaccess.h"
#include "terralib/dataaccess/dataset/DataSetItem.h"
#include "terralib/dataaccess/dataset/DataSetType.h"
#include "terralib/dataaccess/serialization/xml/Serializer.h"
#include "terralib/dataaccess/utils/FieldNameValidator.h"
using namespace te::da;
using namespace te::dt;
%}

%auto_ptr(te::dt::DateTime)
%auto_ptr(te::dt::AbstractData)
%auto_ptr(te::dt::ByteArray)
%auto_ptr(te::dt::Array)
%auto_ptr(te::da::DataSet)
%auto_ptr(DataSet)
%auto_ptr(te::da::DataSource)
%auto_ptr(te::da::DataSourceTransactor)
%auto_ptr(te::da::Sequence)
%auto_ptr(Sequence)
%auto_ptr(te::da::CheckConstraint)
%auto_ptr(te::da::ForeignKey)
%auto_ptr(te::da::PrimaryKey)
%auto_ptr(te::da::UniqueKey)
%auto_ptr(te::da::Index)
%auto_ptr(te::dt::Property)
%auto_ptr(te::da::DataSetTypeCapabilities)
%auto_ptr(te::da::DataSetType)
%auto_ptr(te::da::DataSetTypeConverter)
%auto_ptr(te::gm::Envelope)
%auto_ptr(te::gm::Geometry)
%auto_ptr(te::rst::Raster)
%auto_ptr(te::da::PreparedQuery)
%auto_ptr(PreparedQuery)
%auto_ptr(te::da::BatchExecutor)
%auto_ptr(BatchExecutor)
%auto_ptr(te::da::Fields)
%auto_ptr(te::da::Expression)
%auto_ptr(te::da::Select)

%unique_ptr(te::dt::DateTime)
%unique_ptr(te::dt::AbstractData)
%unique_ptr(te::dt::ByteArray)
%unique_ptr(te::dt::Array)
%unique_ptr(te::da::DataSet)
%unique_ptr(te::da::DataSetItem)
%unique_ptr(te::da::DataSetTypeConverter)
%unique_ptr(te::da::DataSource)
%unique_ptr(te::da::DataSourceTransactor)
%unique_ptr(te::da::Sequence)
%unique_ptr(te::da::CheckConstraint)
%unique_ptr(te::da::ForeignKey)
%unique_ptr(te::da::PrimaryKey)
%unique_ptr(te::da::UniqueKey)
%unique_ptr(te::da::Index)
%unique_ptr(te::dt::Property)
%unique_ptr(te::da::DataSetTypeCapabilities)
%unique_ptr(te::da::DataSetType)
%unique_ptr(te::gm::Envelope)
%unique_ptr(te::gm::Geometry)
%unique_ptr(te::rst::Raster)
%unique_ptr(te::da::PreparedQuery)
%unique_ptr(te::da::BatchExecutor)
%unique_ptr(te::da::Fields)
%unique_ptr(te::da::Expression)
%unique_ptr(te::da::Select)

%nodefaultctor te::da::DataSourceFactory;

%include "terralib/dataaccess/Enums.h"
%include "terralib/dataaccess/dataset/DataSetType.h"
%include "terralib/dataaccess/dataset/DataSet.h"
%include "terralib/dataaccess/dataset/DataSetItem.h"
%include "terralib/dataaccess/dataset/ObjectId.h"
%include "terralib/dataaccess/dataset/ObjectIdSet.h"
%include "terralib/dataaccess/dataset/PrimaryKey.h"
%include "terralib/dataaccess/dataset/DataSetTypeConverter.h"
%include "terralib/dataaccess/datasource/DataSource.h"
%include "terralib/dataaccess/datasource/DataSourceInfo.h"
%include "terralib/dataaccess/datasource/DataSourceManager.h"
%include "terralib/dataaccess/datasource/DataSourceFactory.h"
%include "terralib/dataaccess/datasource/BatchExecutor.h"
%include "terralib/dataaccess/datasource/PreparedQuery.h"
%include "terralib/dataaccess/datasource/DataSourceTransactor.h"
%include "terralib/dataaccess/query/Field.h"
%include "terralib/dataaccess/query/Fields.h"
%include "terralib/dataaccess/utils/FieldNameValidator.h"
%include "terralib/dataaccess/utils/Utils.h"
%include "terralib/dataaccess/datasource/DataSourceInfoManager.h"
%include "terralib/dataaccess/serialization/xml/Serializer.h"



