

%include <exception.i>

%rename(te_Exception) te::Exception;

%{
#include "terralib/Exception.h"
#include <boost/exception/all.hpp>
%}

%import "boost/exception/all.hpp"
%include "terralib/Exception.h"

%exception {
  try 
  {
    $action
  }
  catch(te::Exception &e)
  {
    std::string *d = boost::get_error_info<te::ErrorDescription>(e);
    SWIG_exception(SWIG_RuntimeError, d->c_str());
  }
  catch(std::exception &e)
  {
    SWIG_exception(SWIG_RuntimeError, e.what());
  }
  catch(...)
  {
    SWIG_exception(SWIG_UnknownError, "Unknown error.");
  }
}