#define TERASTEREXPORT

%include Config.i
%module(package="terralib")raster


%include std_complex.i

%rename(make) te::rst::RasterFactory::make;

//SWIG does not support function pointer
%ignore te::rst::Raster::callOperator;
%{
#include "terralib/raster/Band.h"
#include "terralib/raster/BandIterator.h"
#include "terralib/raster/BandIteratorWindow.h"
#include "terralib/raster/BandProperty.h"
#include "terralib/raster/BandSummary.h"
#include "terralib/raster/Enums.h"
#include "terralib/raster/Grid.h"
#include "terralib/raster/Interpolator.h"
#include "terralib/raster/PositionIterator.h"
#include "terralib/raster/ProxyRaster.h"
#include "terralib/raster/Raster.h"
#include "terralib/raster/RasterFactory.h"
#include "terralib/raster/RasterIterator.h"
#include "terralib/raster/RasterProperty.h"
#include "terralib/raster/RasterSummary.h"
#include "terralib/raster/RasterSummaryManager.h"
#include "terralib/raster/RasterSynchronizer.h"
#include "terralib/raster/Reprojection.h"
#include "terralib/raster/SynchronizedBand.h"
#include "terralib/raster/SynchronizedBandBlocksManager.h"
#include "terralib/raster/SynchronizedRaster.h"
#include "terralib/raster/TileIndexer.h"
#include "terralib/raster/Utils.h"
#include "terralib/raster/Vectorizer.h"
#include "terralib/raster/VectorizerPolygonStructure.h"
extern te::rst::Raster* open(const std::string& path);
%}

%inline{
te::rst::Raster* open(const std::string& path)
{
  return te::rst::RasterFactory::open("URI", path);
}
}

%auto_ptr(te::rst::TileIndexer)
%auto_ptr(te::gm::Polygon)

%unique_ptr(te::rst::Raster)
%unique_ptr(te::rst::TileIndexer)
%unique_ptr(te::gm::Polygon)
%unique_member(te::rst::TileIndexer)
%unique_member(te::gm::Polygon)

%include "terralib/raster/Enums.h"
%include "terralib/raster/Band.h"
%include "terralib/raster/BandIterator.h"
%include "terralib/raster/BandIteratorWindow.h"
%include "terralib/raster/BandProperty.h"
%include "terralib/raster/BandSummary.h"
%include "terralib/raster/Grid.h"
%include "terralib/raster/Interpolator.h"
%include "terralib/raster/PositionIterator.h"
%include "terralib/raster/Raster.h"
%include "terralib/raster/ProxyRaster.h"
%include "terralib/raster/RasterFactory.h"
%include "terralib/raster/RasterIterator.h"
%include "terralib/raster/RasterProperty.h"
%include "terralib/raster/RasterSummary.h"
%include "terralib/raster/RasterSummaryManager.h"
%include "terralib/raster/RasterSynchronizer.h"
%include "terralib/raster/Reprojection.h"
%include "terralib/raster/SynchronizedBand.h"
%include "terralib/raster/SynchronizedBandBlocksManager.h"
%include "terralib/raster/SynchronizedRaster.h"
%include "terralib/raster/VectorizerPolygonStructure.h"
%include "terralib/raster/TileIndexer.h"
%include "terralib/raster/Utils.h"
%include "terralib/raster/Vectorizer.h"

