#define TESRSEXPORT

%include Config.i
%module(package="terralib") srs


%import "terralib/common/Singleton.h"

%ignore te::srs::SpatialReferenceSystemManager::getIterators;
%ignore te::srs::SpatialReferenceSystemManager::getSpatialReferenceSystem;

%{
#include "terralib/srs/Config.h"
#include "terralib/srs/Converter.h"
#include "terralib/srs/Datum.h"
#include "terralib/srs/Ellipsoid.h"
#include "terralib/srs/GeographicCoordinateSystem.h"
#include "terralib/srs/Module.h"
#include "terralib/srs/ProjectedCoordinateSystem.h"
#include "terralib/srs/SpatialReferenceSystem.h"
#include "terralib/srs/SpatialReferenceSystemManager.h"
%}

namespace te {
  namespace common {
    %template(SpatialReferenceSystemManagerSingleton) Singleton < te::srs::SpatialReferenceSystemManager >;
  }
}

typedef te::common::Singleton< te::srs::SpatialReferenceSystemManager > SpatialReferenceSystemManagerSingleton;

%auto_ptr(te::srs::SpatialReferenceSystem)

%include "terralib/srs/Config.h"
%include "terralib/srs/Converter.h"
%include "terralib/srs/Datum.h"
%include "terralib/srs/Ellipsoid.h"
%include "terralib/srs/GeographicCoordinateSystem.h"
%include "terralib/srs/Module.h"
%include "terralib/srs/ProjectedCoordinateSystem.h"
%include "terralib/srs/SpatialReferenceSystem.h"
%include "terralib/srs/SpatialReferenceSystemManager.h"