/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/classification.h

  \brief This file contains include headers for the TerraLib Classification module.
*/

#ifndef __TERRALIB_INTERNAL_CLASSIFICATION_H
#define __TERRALIB_INTERNAL_CLASSIFICATION_H

// TerraLib
#include "classification/Adaptors.h"
#include "classification/Config.h"
#include "classification/Dummy.h"
#include "classification/Enums.h"
#include "classification/Exception.h"
#include "classification/ISOData.h"
#include "classification/KMeans.h"
#include "classification/MAP.h"
#include "classification/MaxLikelihood.h"
#include "classification/ROI.h"
#include "classification/ROISet.h"
#include "classification/Utils.h"

/*!
  \defgroup cl Classification

  \brief This module provides classes and functions with generic classification capabilities.

    Basically, the TerraLib Classification module contains several generic classification operations applied to any data type.
    The main classes/concepts in this module are listed here. The namespace associated to the Classification module is te::cl.
    To know more about it, see the te::cl namespace documentation.
*/

namespace te
{
  /*!
    \brief Namespace for classification module of TerraLib.
  */
  namespace cl
  {
  } // end namespace rp
}   // end namespace te

#endif  // __TERRALIB_INTERNAL_CLASSIFICATION_H
