/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/core/plugin.h

  \brief Include files for Core Plugin Library.
*/

#ifndef __TERRALIB_CORE_PLUGIN_H__
#define __TERRALIB_CORE_PLUGIN_H__

// TerraLIb
#include "plugin/AbstractPlugin.h"
#include "plugin/AbstractPluginEngine.h"
#include "plugin/CppPlugin.h"
#include "plugin/CppPluginEngine.h"
#include "plugin/Exception.h"
#include "plugin/Finders.h"
#include "plugin/PluginEngineManager.h"
#include "plugin/PluginInfo.h"
#include "plugin/PluginManager.h"
#include "plugin/Serializers.h"
#include "plugin/Utils.h"

#endif // __TERRALIB_CORE_PLUGIN_H__
