#include "ProxyInfo.h"

te::core::ProxyInfo::ProxyInfo() 
  : m_port(-1)
  , m_isEnabled(false)
{
}

const std::string& te::core::ProxyInfo::getHost() const
{
  return m_host;
}

void te::core::ProxyInfo::setHost(const std::string& host)
{
  m_host = host;
}

int te::core::ProxyInfo::getPort() const
{
  return m_port;
}

void te::core::ProxyInfo::setPort(int port)
{
  m_port = port;
}

const std::string& te::core::ProxyInfo::getUserName() const
{
  return m_userName;
}

void te::core::ProxyInfo::setUserName(const std::string& userName)
{
  m_userName = userName;
}

const std::string& te::core::ProxyInfo::getPassword() const
{
  return m_password;
}

void te::core::ProxyInfo::setPassword(const std::string& password)
{
  m_password = password;
}

bool te::core::ProxyInfo::isEnabled() const
{
  return m_isEnabled;
}

void te::core::ProxyInfo::setEnabled(bool enabled)
{
  m_isEnabled = enabled;
}

bool te::core::ProxyInfo::isAuthenticated() const
{
  if (m_userName.empty() == false && m_password.empty() == false)
  {
    return true;
  }

  return false;
}

std::string te::core::ProxyInfo::getHostPort() const
{
  std::string asString;
  if(m_host.empty() == true)
  {
    return asString;
  }

  asString += m_host;
  if(m_port >= 0)
  {
    asString += ":" + std::to_string(m_port);
  }

  return asString;
}

std::string te::core::ProxyInfo::getAuthentication() const
{
  std::string asString;
  if(isAuthenticated() == true)
  {
    asString += m_userName;
    asString += ":";
    asString += m_password;
  }

  return asString;
}

std::string te::core::ProxyInfo::toString() const
{
  if(m_host.empty() == true)
  {
    return "";
  }

  std::string authentication = getAuthentication();
  std::string hostPort = getHostPort();

  std::string asString;  
  if(authentication.empty() == false)
  {
    asString += authentication;
    asString += "@";
  }
  
  asString += hostPort;
  return asString;
}
