/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/core/utils/Utils.h
*/

#ifndef __TERRALIB_CORE_UTILS_UTILS_H__
#define __TERRALIB_CORE_UTILS_UTILS_H__

// TerraLib
#include "../Config.h"

// STL
#include <string>

namespace te
{
  namespace core
  {
    TECOREEXPORT std::string ASCIIToHex(const std::string& text);
    TECOREEXPORT std::string HexToASCII(const std::string& text);
    TECOREEXPORT std::string URIConvertASCIIToHex(const std::string& connInfo);
    TECOREEXPORT std::string URIConvertHexToASCII(const std::string& connInfo);
    TECOREEXPORT std::string URIConvertASCIIToHex(const std::string& connInfo);
    TECOREEXPORT std::string encodeBase64(const std::string &val);
    TECOREEXPORT std::string decodeBase64(const std::string &val);

  }  // end namespace core
}    // end namespace te

#endif //__TERRALIB_CORE_UTILS_UTILS_H__
