/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/dataaccess/query/LiteralGeom.cpp

  \brief A class that models a literal for Geometry values.
*/

// TerraLib
#include "../../geometry/Geometry.h"
#include "LiteralGeom.h"

te::da::LiteralGeom::LiteralGeom(te::gm::Geometry* g)
  : Literal(g)
{
}

te::da::LiteralGeom::LiteralGeom(const te::gm::Geometry& g)
  : Literal(g.clone())
{
}

te::da::LiteralGeom::LiteralGeom(const LiteralGeom& rhs)

    = default;

te::da::LiteralGeom::~LiteralGeom() = default;

te::da::LiteralGeom& te::da::LiteralGeom::operator=(const LiteralGeom& rhs) =
    default;

te::da::Expression* te::da::LiteralGeom::clone() const
{
  return new LiteralGeom(*this);
}

