/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file LogicOp.cpp
  
  \brief A logical operator can be used to combine one or more conditional expressions.  
 */

// TerraLib
#include "LogicOp.h"

te::fe::LogicOp::LogicOp(const char* opName)
  : AbstractOp(opName)
{
}

te::fe::LogicOp::~LogicOp() = default;

te::fe::AbstractOp *te::fe::LogicOp::clone() const
{
  LogicOp* logic = new LogicOp;

  if(m_name)
    logic->setName(m_name);

  return logic;
}
