/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

This file is part of the TerraLib - a Framework for building GIS enabled applications.

TerraLib is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License,
or (at your option) any later version.

TerraLib is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with TerraLib. See COPYING. If not, write to
TerraLib Team at <terralib-team@terralib.org>.
*/

/*!
\file Utils.h

\brief This file has util functions for this module.
*/

#ifndef __TERRALIB_FE_INTERNAL_UTILS_H
#define __TERRALIB_FE_INTERNAL_UTILS_H

// TerraLib
#include "Config.h"
#include "Filter.h"


namespace te
{
  namespace fe
  {

    TEFEEXPORT te::fe::Filter* CreateFilterByUniqueValue(const std::string& attrName, const std::string& value);

    TEFEEXPORT void GetFilterUniqueValue(const te::fe::Filter* filter, std::string& value);

    TEFEEXPORT te::fe::Filter* CreateFilterByStep(const std::string& attrName, const std::string& minValue, const std::string& maxValue);

    TEFEEXPORT void GetFilterStepValues(const te::fe::Filter* filter, std::string& valueMin, std::string& valueMax);

  } // end namespace fe
}     // end namespace te

#endif  // __TERRALIB_FE_INTERNAL_SORTBY_H
