/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

 /*!
   \file terralib/geometry/InternalConfig.h

   \brief This is an internal configuration file that adds information about geos. It must not be included in any header and is intended for internal use only
 */

#ifndef __TERRALIB_GEOMETRY_INTERNAL_INTERNALCONFIG_H
#define __TERRALIB_GEOMETRY_INTERNAL_INTERNALCONFIG_H

#include <geos/version.h>

 /** @name GEOS Config
  *  Defines when using GEOS in TerraLib.
  */
  //@{

  /*!
    \def GEOS_FULLVERSION

    \brief Sets the GEOS_FULLVERSION as as comparable number resuting from the concatenatuon of the version parts  */
#ifndef GEOS_FULLVERSION
#define GEOS_FULLVERSION (GEOS_VERSION_MAJOR * 10000) + (GEOS_VERSION_MINOR * 100) + GEOS_VERSION_PATCH
#endif // !GEOS_FULLVERSION

  //@}

#endif  // __TERRALIB_GEOMETRY_INTERNAL_INTERNALCONFIG_H


