/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/process/Config.h

  \brief Configuration flags for TerraLib Process.
*/

#ifndef __TERRALIB_PROCESS_CONFIG_H__
#define __TERRALIB_PROCESS_CONFIG_H__

// TerraLib
#include "../Defines.h"

#ifdef WIN32
  #ifdef _MSC_VER 
    #pragma warning( disable : 4251 )
    #pragma warning( disable : 4275 )
    #pragma warning( disable : 4290 )
    #pragma warning( disable : 4503 ) // for no properly declared STL object in the class boundaries.
  #endif

#ifdef TEPROCESSDLL
    #define TEPROCESSEXPORT TE_DLL_EXPORT
#else
    #define TEPROCESSEXPORT TE_DLL_IMPORT
  #endif
#else
  #define TEPROCESSEXPORT
#endif

#endif  // __TERRALIB_PROCESS_CONFIG_H__
