/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

 /*!
   \file terralib/process/ParameterDescriptor.cpp

   \brief This class represents the description of a parameter
 */

#include "ParameterValue.h"

te::process::ParameterValue::ParameterValue(int dataType)
  : m_dataType(dataType)
{

}

te::process::ParameterValue::~ParameterValue() = default;

int te::process::ParameterValue::getDataType() const
{
  return m_dataType;
}

te::process::ParameterValueFactory::ParameterValueFactory(int dataType)
  : te::common::AbstractFactory<te::process ::ParameterValue, int>(dataType)
{

}

te::process::ParameterValueFactory::~ParameterValueFactory() = default;

te::process::ParameterValue* te::process::CreateParameterValue(int dataType)
{
  return te::process::ParameterValueFactory::make(dataType);
}
