#include "DataAccessTaskCapabilities.h"

// TerraLib Includes
#include "../../../qt/widgets/Utils.h"

te::process::qt::DataAccessTaskCapabilities::DataAccessTaskCapabilities()
  : TaskGraphicalCapabilities("DataAccessTask", "Data Access Task", "datasource", "share/terralib/icons/terralib/scalable/datasource.svg")
{
  m_brushColor = QColor(145, 210, 144);
}

te::process::qt::DataAccessTaskCapabilities::~DataAccessTaskCapabilities() = default;

QPainterPath te::process::qt::DataAccessTaskCapabilities::getShape(QList<QPointF>& inHotPoints, QList<QPointF>& outHotPoints) const
{
  QPainterPath path;
  path.moveTo(20, 10);
  path.lineTo(60, 10);
  path.lineTo(40, 50);
  path.lineTo(0, 50);
  path.lineTo(20, 10);

  path.moveTo(0, 23);
  path.lineTo(13, 23);
  path.moveTo(0, 37);
  path.lineTo(6, 37);

  path.moveTo(60, 30);
  path.lineTo(50.5, 30);

  inHotPoints.append(QPointF(3, 23));
  inHotPoints.append(QPointF(3, 37));

  outHotPoints.append(QPointF(57, 30));

  return path;
}

QRectF te::process::qt::DataAccessTaskCapabilities::shapeBoundingRect() const
{
  return QRectF(0, 0, 60, 60);
}

te::process::qt::DataAccessTaskCapabilitiesFactory::DataAccessTaskCapabilitiesFactory()
  : TaskGraphicalCapabilitiesFactory("DataAccessTask")
{

}

te::process::qt::DataAccessTaskCapabilitiesFactory::~DataAccessTaskCapabilitiesFactory() = default;

te::process::qt::TaskGraphicalCapabilities* te::process::qt::DataAccessTaskCapabilitiesFactory::build()
{
  return new te::process::qt::DataAccessTaskCapabilities();
}