#include "DataStoreTaskCapabilities.h"

// TerraLib Includes
#include "../../../qt/widgets/Utils.h"

te::process::qt::DataStoreTaskCapabilities::DataStoreTaskCapabilities()
  : TaskGraphicalCapabilities("DataStoreTask", "Data Store Task", "datasource", "share/terralib/icons/terralib/scalable/datasource.svg")
{
  m_brushColor = QColor(111, 183, 214);
}

te::process::qt::DataStoreTaskCapabilities::~DataStoreTaskCapabilities() = default;

QPainterPath te::process::qt::DataStoreTaskCapabilities::getShape(QList<QPointF>& inHotPoints, QList<QPointF>& outHotPoints) const
{
  QPainterPath path;
  path.moveTo(10, 10);
  path.lineTo(40, 10);
  path.lineTo(50, 30);
  path.lineTo(40, 50);
  path.lineTo(10, 50);
  path.lineTo(10, 10);

  path.moveTo(0, 20);
  path.lineTo(10, 20);
  path.moveTo(0, 30);
  path.lineTo(10, 30);
  path.moveTo(0, 40);
  path.lineTo(10, 40);
  
  path.moveTo(60, 30);
  path.lineTo(50, 30);

  inHotPoints.append(QPointF(3, 20));
  inHotPoints.append(QPointF(3, 30));
  inHotPoints.append(QPointF(3, 40));

  outHotPoints.append(QPointF(57, 30));

  return path;
}

QRectF te::process::qt::DataStoreTaskCapabilities::shapeBoundingRect() const
{
  return QRectF(0, 0, 60, 60);
}

te::process::qt::DataStoreTaskCapabilitiesFactory::DataStoreTaskCapabilitiesFactory()
  : TaskGraphicalCapabilitiesFactory("DataStoreTask")
{

}

te::process::qt::DataStoreTaskCapabilitiesFactory::~DataStoreTaskCapabilitiesFactory() = default;

te::process::qt::TaskGraphicalCapabilities* te::process::qt::DataStoreTaskCapabilitiesFactory::build()
{
  return new te::process::qt::DataStoreTaskCapabilities();
}