#include "TaskGraphicalCapabilities.h"

// TerraLib Includes
#include "../../../core/utils.h"
#include "../../../qt/widgets/Utils.h"

te::process::qt::TaskGraphicalCapabilities::TaskGraphicalCapabilities(
  const std::string& operationName
, const std::string& description
, const std::string& iconName
, const std::string& iconPath
)
  : m_operationName(operationName)
  , m_description(description)
  , m_iconName(iconName)
  , m_iconPath(iconPath)
{
  m_qIcon = QIcon::fromTheme(te::qt::widgets::Convert2QString(m_iconName));
}

te::process::qt::TaskGraphicalCapabilities::~TaskGraphicalCapabilities() = default;

std::string te::process::qt::TaskGraphicalCapabilities::getName() const
{
  return m_operationName;
}

std::string te::process::qt::TaskGraphicalCapabilities::getDescription() const
{
  return m_description;
}

std::string te::process::qt::TaskGraphicalCapabilities::getIconPath() const
{
  return te::core::FindInTerraLibPath(m_iconPath);
}

const QIcon& te::process::qt::TaskGraphicalCapabilities::getIcon() const
{
  return m_qIcon;
}

te::process::qt::TaskGraphicalCapabilitiesFactory::TaskGraphicalCapabilitiesFactory(const std::string& factoryKey)
  : te::common::AbstractFactory < TaskGraphicalCapabilities, std::string >(factoryKey)
{

}

te::process::qt::TaskGraphicalCapabilitiesFactory::~TaskGraphicalCapabilitiesFactory() = default;
