#include "DataAccessTreeItem.h"

#include "TaskMimeData.h"

#include "../../DataAccessTaskProcess.h"


te::process::qt::DataAccessTreeItem::DataAccessTreeItem(QTreeWidgetItem* parent, te::qt::widgets::DataSourceType* type) :
  ProcessTreeItem(parent, ITEM_TREEITEMTYPE),
  m_dsType(type)
{
  QString dsName = QString::fromUtf8(type->getName().c_str());
  QIcon icon = type->getIcon(te::qt::widgets::DataSourceType::ICON_DATASOURCE_SMALL);
  QString title = QString::fromUtf8(type->getTitle().c_str());
  QString description = QString::fromUtf8(type->getDescription().c_str());

  setText(0, title);
  setIcon(0, icon);
  setData(0, Qt::UserRole, QVariant(dsName));

  parent->addChild(this);
  parent->setExpanded(true);
}

te::process::qt::DataAccessTreeItem::~DataAccessTreeItem() = default;

QMimeData* te::process::qt::DataAccessTreeItem::getMimeData()
{
  te::process::TaskSharedPtr task(te::process::CreateTask("DataAccessTask"));

  te::process::DataAccessTask* dataAccessTask = dynamic_cast<te::process::DataAccessTask*>(task.get());

  if (dataAccessTask)
  {
    dataAccessTask->setDataSourceType(m_dsType->getName());
  }

  TaskMimeData* taskMimeData = new TaskMimeData(task);

  return taskMimeData;
}

