#include "DataStoreProcessTreeGroup.h"

#include "DataStoreTreeItem.h"

// TerraLib Includes
#include "../../../qt/widgets/datasource/core/DataSourceType.h"
#include "../../../qt/widgets/datasource/core/DataSourceTypeManager.h"



te::process::qt::DataStoreProcessTreeGroup::DataStoreProcessTreeGroup(te::process::qt::ProcessExplorerTree* parent) :
  AbstractProcessTreeGroup(parent, "Data Store")
{
  setupGroup();
}


te::process::qt::DataStoreProcessTreeGroup::~DataStoreProcessTreeGroup() = default;


void te::process::qt::DataStoreProcessTreeGroup::setupGroup()
{
  std::map<std::string, te::qt::widgets::DataSourceType*>::const_iterator it = te::qt::widgets::DataSourceTypeManager::getInstance().begin();
  std::map<std::string, te::qt::widgets::DataSourceType*>::const_iterator itend = te::qt::widgets::DataSourceTypeManager::getInstance().end();

  while (it != itend)
  {
    DataStoreTreeItem* dsTreeItem = new DataStoreTreeItem(m_root, it->second);

    ++it;
  }
}
