/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*! 
  \file terralib/process/qt/DataStoreTreeItem.h

  \brief A QTreeWidgetItem to represents a DataStore Task Process Builder items in a tree.
*/

#ifndef __TERRALIB_PROCESS_QT_INTERNAL_DATASTORETREEITEM_H
#define __TERRALIB_PROCESS_QT_INTERNAL_DATASTORETREEITEM_H

#include "../../Config.h"

#include "../../Task.h"

// TerraLib Includes
#include "../../../qt/widgets/datasource/core/DataSourceType.h"

// Qt Includes
#include "ProcessTreeItem.h"

namespace te
{
  namespace process
  {
    namespace qt
    {
      /*!
      \class DataStoreTreeItem

      \brief A QTreeWidgetItem to represents a DataStore Task Process Builder items in a tree.

      */
      class TEPROCESSEXPORT DataStoreTreeItem : public ProcessTreeItem
      {
      public:

        /*! \brief Default constructor. */
        DataStoreTreeItem(QTreeWidgetItem* parent, te::qt::widgets::DataSourceType* type);

        /*! \brief Virtual destructor. */
        ~DataStoreTreeItem();

      public:

        QMimeData* getMimeData() override;

      protected:

        te::qt::widgets::DataSourceType* m_dsType;
      };
    }
  }
}

#endif // __TERRALIB_PROCESS_QT_INTERNAL_DATASTORETREEITEM_H
