#include "ProcessExplorerTree.h"

#include "ProcessTreeItem.h"

// Qt Includes
#include <QByteArray>
#include <QHeaderView>
#include <QMimeData>

te::process::qt::ProcessExplorerTree::ProcessExplorerTree(QWidget *parent) :
  QTreeWidget(parent)
{
  this->header()->setVisible(false);
  this->setDragEnabled(true);

  setupTree();

  setIconSize(QSize(32, 32));
}

te::process::qt::ProcessExplorerTree::~ProcessExplorerTree() = default;

void te::process::qt::ProcessExplorerTree::setupTree()
{

}

QMimeData* te::process::qt::ProcessExplorerTree::mimeData(const QList<QTreeWidgetItem*> items) const
{
  if (items.size() != 1)
  {
    return nullptr;
  }

  QTreeWidgetItem* item = items.at(0);

  if (item->type() != te::process::qt::ProcessTreeItem::ITEM_TREEITEMTYPE)
  {
    return nullptr;
  }

  //check if item is a TaskProcessTreeItem
  ProcessTreeItem* processItem = dynamic_cast<ProcessTreeItem*>(item);
  if (processItem)
  {
    return processItem->getMimeData();
  }

  return nullptr;
}
