#include "HotPointGraphicsItem.h"

// Qt Includes
#include <QBrush>
#include <QPainter>

te::process::qt::HotPointGraphicsItem::HotPointGraphicsItem(const QPointF& position, const std::size_t& index, const std::string& taskId) :
  QGraphicsObject(),
  m_pos(position),
  m_index(index),
  m_taskId(taskId),
  m_color(Qt::red)
{
  setAcceptHoverEvents(true);
}

te::process::qt::HotPointGraphicsItem::~HotPointGraphicsItem() = default;

QPointF te::process::qt::HotPointGraphicsItem::getHotPointPos()
{
  return m_pos;
}

QRectF te::process::qt::HotPointGraphicsItem::boundingRect() const
{
  return QRectF(0, 0, 5, 5);
}

void te::process::qt::HotPointGraphicsItem::paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget)
{
  QPen pointPen(m_color);
  pointPen.setCapStyle(Qt::RoundCap);
  pointPen.setWidth(6);

  painter->setPen(pointPen);
  painter->drawPoint(m_pos);

  if (m_color != Qt::red && m_color != Qt::blue)
  {
    m_color = Qt::red;
  }
}

void te::process::qt::HotPointGraphicsItem::setHotPointColor(QColor color)
{
  m_color = color;
}

std::size_t  te::process::qt::HotPointGraphicsItem::getHotPointIndex() const
{
  return m_index;
}