#include "ProcessGraphicsView.h"

//Qt Includes
#include <QWheelEvent>

te::process::qt::ProcessGraphicsView::ProcessGraphicsView(QGraphicsScene* scene, QWidget* parent) :
  QGraphicsView(scene, parent)
{
  setAcceptDrops(true);
  setBackgroundBrush(QColor(230, 230, 230));
  setMouseTracking(true);
  setRenderHint(QPainter::Antialiasing);
  setUpdatesEnabled(true);
  setViewportUpdateMode(QGraphicsView::BoundingRectViewportUpdate);
}

te::process::qt::ProcessGraphicsView::~ProcessGraphicsView() = default;

void te::process::qt::ProcessGraphicsView::wheelEvent(QWheelEvent *event)
{
  if (event->delta() > 0)
    scale(1.25, 1.25);
  else
    scale(0.8, 0.8);
}