#include "TaskProperty.h"

#include "GraphicsPropertyItem.h"
#include "TaskPropertyItem.h"

// Qt
#include <QGridLayout>

// QtPropertyBrowser
#include <QtPropertyBrowser/QtTreePropertyBrowser>

te::process::qt::TaskProperty::TaskProperty(ProcessManager* manager, QWidget *parent) :
  QWidget(parent)
{
  QGridLayout* layout = new QGridLayout(this);
  layout->setContentsMargins(0, 0, 0, 0);
  setLayout(layout);

  QtTreePropertyBrowser* propBrowser = new QtTreePropertyBrowser(this);
  propBrowser->setIndentation(10);
  propBrowser->setPropertiesWithoutValueMarked(true);
  propBrowser->setRootIsDecorated(false);
  propBrowser->setResizeMode(QtTreePropertyBrowser::ResizeToContents);

  layout->addWidget(propBrowser);

  m_traskPropertyItem = new te::process::qt::TaskPropertyItem(propBrowser, this, manager);

  m_graphicsPropertyItem = new te::process::qt::GraphicsPropertyItem(propBrowser);
}

te::process::qt::TaskProperty::~TaskProperty() = default;

void te::process::qt::TaskProperty::setTask(const std::string& taskId)
{
  m_traskPropertyItem->setTask(taskId);
}

void te::process::qt::TaskProperty::setTaskItem(AbstractGraphicsItem* item)
{
  m_graphicsPropertyItem->setItem(item);
}

void te::process::qt::TaskProperty::handleValueChanged(QtProperty* qProperty, const QVariant& qVariant)
{

}
