/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

 /*!
   \file terralib/process/qt/property/TaskPropertyItemListener.h

   \brief A base item to represent the process task items in property listener.
 */

#ifndef __TERRALIB_PROCESS_QT_INTERNAL_TASKPROPERTYITEMLISTENER_H
#define __TERRALIB_PROCESS_QT_INTERNAL_TASKPROPERTYITEMLISTENER_H

 // TerraLib
#include "../../Config.h"

class QVariant;
class QtProperty;

namespace te
{
  namespace process
  {
    namespace qt
    {
      /*!
        \class TaskPropertyItemListener

        \brief A base item to represent the process task items in property listener.
      */

      class TEPROCESSEXPORT TaskPropertyItemListener
      {

      public:

        /*! \brief Constructor */
        TaskPropertyItemListener()= default;

        /*! \brief Destructor. */
        virtual ~TaskPropertyItemListener() = default;

        //!< This function will be called every time a value has changed
        virtual void handleValueChanged(QtProperty* qProperty, const QVariant& qVariant) = 0;
      };
    }
  }
}

#endif //__TERRALIB_PROCESS_QT_INTERNAL_TASKPROPERTYITEMLISTENER_H
