/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

This file is part of the TerraLib - a Framework for building GIS enabled applications.

TerraLib is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License,
or (at your option) any later version.

TerraLib is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with TerraLib. See COPYING. If not, write to
TerraLib Team at <terralib-team@terralib.org>.
*/

/*!
\file terralib/qt/af/ThirdPartyInfo.h

\brief A class used to get information about terralib apps dependencies.
*/

#ifndef __TERRALIB_QT_AF_INTERNAL_THIRDPARTYINFO_H
#define __TERRALIB_QT_AF_INTERNAL_THIRDPARTYINFO_H

#include "Config.h"

// STL Includes
#include <string>

namespace te
{
  namespace qt
  {
    namespace af
    {
      class TEQTAFEXPORT ThirdPartyInfo
      {
        public:

          ThirdPartyInfo();

          ~ThirdPartyInfo();

        public:

          static std::string getQtVersion();

          static std::string getGDALVersion();

          static std::string getBoostVersion();

          static std::string getGeosVersion();

          static std::string getProjVersion();

          static std::string getQwtVersion();

          static std::string getSQLiteVersion();

          static std::string getPostgreSQLVersion();

      };
    }
  }
}

#endif //__TERRALIB_QT_AF_INTERNAL_THIRDPARTYINFO_H
