/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

This file is part of the TerraLib - a Framework for building GIS enabled applications.

TerraLib is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License,
or (at your option) any later version.

TerraLib is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with TerraLib. See COPYING. If not, write to
TerraLib Team at <terralib-team@terralib.org>.
*/

/*!
\file terralib/qt/af/ThirdPartyInfoWidget.h

\brief A Widget used to inform about third party versions
*/

#ifndef __TERRALIB_QT_AF_INTERNAL_THIRDPARTYINFOWIDGET_H
#define __TERRALIB_QT_AF_INTERNAL_THIRDPARTYINFOWIDGET_H

#include "Config.h"

//Qt
#include <QTableWidget>
#include <QWidget>

namespace te
{
  namespace qt
  {
    namespace af
    {
      class TEQTAFEXPORT ThirdPartyInfoWidget : public QWidget
      {
        Q_OBJECT

        public:

          ThirdPartyInfoWidget(QWidget* parent = 0, Qt::WindowFlags f = 0);

          ~ThirdPartyInfoWidget();

        protected:

          void buildUi();

          void getThirdPartyInfo();

          void addThirdPartyInfo(std::string name, std::string version);

        protected:

          QTableWidget* m_thirdPartyTableWidget;
      };
    }
  }
}

#endif //__TERRALIB_QT_AF_INTERNAL_THIRDPARTYINFOWIDGET_H
