#include "TableWidget.h"
#include "TableWidgetFactory.h"

te::qt::af::TableWidgetFactory* te::qt::af::TableWidgetFactory::sm_factory(nullptr);


void te::qt::af::TableWidgetFactory::initialize()
{
  finalize();
  sm_factory = new TableWidgetFactory;
}

void te::qt::af::TableWidgetFactory::finalize()
{
  delete sm_factory;
  sm_factory = nullptr;
}

te::qt::af::TableWidgetFactory::~TableWidgetFactory() = default;

te::qt::af::AbstractSettingWidget* te::qt::af::TableWidgetFactory::build()
{
  return new TableWidget;
}

te::qt::af::TableWidgetFactory::TableWidgetFactory() :
te::qt::af::SettingsWidgetsFactory(QObject::tr("Table").toUtf8().data())
{

}

te::qt::af::AbstractSettingWidget* te::qt::af::TableWidgetFactory::create(QWidget* parent)
{
  return new TableWidget(parent);
}