/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
\file terralib/qt/plugins/datasource/pgis/RasterPropertiesInfo.h

\brief A QtPropertyBrowser component to show raster properties.
*/

#ifndef __TERRALIB_QT_PLUGINS_DATASOURCE_PGISRASTER_INTERNAL_RASTERPROPERTIESINFO_H
#define __TERRALIB_QT_PLUGINS_DATASOURCE_PGISRASTER_INTERNAL_RASTERPROPERTIESINFO_H

#include "../../../../qt/widgets/propertybrowser/AbstractPropertyItem.h"

namespace te
{
  // Forward declaration
  namespace rst
  {
     class Raster;
  }

  namespace qt
  {
    namespace widgets
    {
      class AbstractPropertyItem;
    }

    namespace plugins
    {
      namespace pgisRaster
      {
        class RasterPropertiesInfo : public te::qt::widgets::AbstractPropertyItem
        {
          Q_OBJECT

          public:

            /*! \brief Constructor */
            RasterPropertiesInfo(QtTreePropertyBrowser* pb, te::rst::Raster* raster);

            /*! \brief Destructor. */
            virtual ~RasterPropertiesInfo();
        };
      }
    }
  }
}

#endif //__TERRALIB_QT_PLUGINS_DATASOURCE_PGISRASTER_INTERNAL_RASTERPROPERTIESINFO_H
