/*
  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

  This file is part of the TerraLib - a Framework for building GIS enabled
  applications.

  TerraLib is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License,
  or (at your option) any later version.

  TerraLib is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TerraLib. See COPYING. If not, write to
  TerraLib Team at <terralib-team@terralib.org>.
*/

/*!
  \file terralib/qt/plugins/timeviewer/Config.h

  \brief Config.h file.
  
  \author Carolina Galvão dos Santos
  \author Matheus Cavassan Zaglia
 */

#ifndef __TERRALIB_QT_PLUGINS_TIMEVIEWER_INTERNAL_CONFIG_H__
#define __TERRALIB_QT_PLUGINS_TIMEVIEWER_INTERNAL_CONFIG_H__

#define TE_QT_TIMEVIEWER_PLUGIN_NAME "te.qt.timeviewer"

#include "../../../Defines.h"

#ifdef WIN32
  #ifdef TETIMEVIEWERDLL
    #define TETIMEVIEWEREXPORT TE_DLL_EXPORT
  #else
    #define TETIMEVIEWEREXPORT TE_DLL_IMPORT
  #endif
#else
  #define TETIMEVIEWEREXPORT
#endif

#endif  // __TERRALIB_QT_PLUGINS_TIMEVIEWER_INTERNAL_CONFIG_H__
