#include "CustomColorCatalogDialog.h"

//TerraLib
#include "../../../color/ColorBar.h"
#include "../../../color/Utils.h"
#include "../../../color/RGBAColor.h"

#include "ui/ui_CustomColorCatalogDialogForm.h"

#include <QPushButton>
#include <QMessageBox>


te::qt::widgets::CustomColorCatalogDialog::CustomColorCatalogDialog(QWidget* parent, Qt::WindowFlags f) :
  QDialog(parent, f), m_ui(new Ui::CustomColorCatalogDialogForm)
{
  m_ui->setupUi(this);

  connect(m_ui->m_okPushButton, SIGNAL(clicked()), SLOT(onOkPushButtonClicked()));
}

te::qt::widgets::CustomColorCatalogDialog::~CustomColorCatalogDialog()
{
  //delete m_ui;
}

void te::qt::widgets::CustomColorCatalogDialog::setColorBar(te::color::ColorBar* colorBar)
{
  m_colorBar = colorBar;
}

void te::qt::widgets::CustomColorCatalogDialog::onOkPushButtonClicked()
{
  std::string group = m_ui->m_groupLineEdit->text().toUtf8().data();
  if (group.empty())
  {
    QMessageBox::warning(this, tr("Custom Color Catalog"), tr("The group was not defined."));
    return;
  }

  std::string schema = m_ui->m_schemaLineEdit->text().toUtf8().data();
  if (schema.empty())
  {
    QMessageBox::warning(this, tr("Custom Color Catalog"), tr("The scheme was not defined."));
    return;
  }

  std::vector<te::color::RGBAColor> colorVec = m_colorBar->getSlices(static_cast<int>(m_colorBar->getColorMap().size()));

  if (!te::color::saveCustomColorBar(group, schema, colorVec))
  {
    QMessageBox::information(this, tr("Custom Color Catalog"), tr("Error: could not save the color bar."));
    return;
  }

  accept();
}
