/*  Copyright (C) 2017 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/qt/widgets/layer/info/DefaultFeatureInfoMakerFactory.h

  \brief DefaultFeatureInfoMakerFactory is an implementation of a factory to make
  DefaultFeatureInfoMaker objects.
*/

#ifndef __TERRALIB_QT_WIDGETS_LAYER_INTERNAL_DEFAULTFEATUREINFOMAKERFACTORY_H
#define __TERRALIB_QT_WIDGETS_LAYER_INTERNAL_DEFAULTFEATUREINFOMAKERFACTORY_H

//TerraLib
#include "../../Config.h"
#include "FeatureInfoMakerFactory.h"
#include "AbstractFeatureInfoMaker.h"

namespace te
{
  namespace qt
  {
    namespace widgets
    {

    class TEQTWIDGETSEXPORT DefaultFeatureInfoMakerFactory : public FeatureInfoMakerFactory
    {

    public:


      /*! \brief Destructor. */
      virtual ~DefaultFeatureInfoMakerFactory();

    protected:

      /*! \brief Default constructor. */
      DefaultFeatureInfoMakerFactory();

      /*! \brief Builds a new  DefaultFeatureInfoMaker object. */
      AbstractFeatureInfoMaker* build();

    private:

      static DefaultFeatureInfoMakerFactory sm_factory; //!< Static attribute used to register this factory
    };

    }
  }
}

#endif //__TERRALIB_QT_WIDGETS_LAYER_INTERNAL_DEFAULTFEATUREINFOMAKERFACTORY_H
