/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.
  
    This file is part of the TerraLib - a Framework for building GIS enabled applications.
    
    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.
    
    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */


#ifndef TE_QT_WIDGETS_RASTERSTATISTICSWIZARDLOG_H
#define TE_QT_WIDGETS_RASTERSTATISTICSWIZARDLOG_H

//Terralib
#include "../Config.h"

//Qt

#include <QDialog>

//STL
#include <memory>

//Forward declarations
namespace Ui
{
  class RasterStatisticsWizardLogForm;
}

namespace te 
{
  namespace qt 
  {
    namespace widgets 
    {
      class TEQTWIDGETSEXPORT RasterStatisticsWizardLog : public QDialog
      {
        Q_OBJECT
        
        public :
        
          RasterStatisticsWizardLog( QWidget* parent=0 );
          ~RasterStatisticsWizardLog();
          void clearAllText();
          void addTextLine( const std::string& textLine );
          
        protected slots:
          
          void savePushButtonPressed(bool checked);
          void closePushButtonPressed(bool checked);
          
        protected :
        
          std::unique_ptr<Ui::RasterStatisticsWizardLogForm> m_uiLogForm;
      };
    } // namespace widgets
  } // namespace qt
} // namespace te

#endif // TE_QT_WIDGETS_RASTERSTATISTICSWIZARDPAGE_H
