/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

 /*!
   \file terralib/qt/widgets/se/StylePropertyItemListener.h

   \brief A bse item to represent the style items in property listener.
 */

#ifndef __TERRALIB_QT_WIDGETS_SE_INTERNAL_STYLEPROPERTYITEMLISTENER_H
#define __TERRALIB_QT_WIDGETS_SE_INTERNAL_STYLEPROPERTYITEMLISTENER_H

 // TerraLib
#include "../Config.h"

class QVariant;
class QtProperty;

namespace te
{
  namespace qt
  {
    namespace widgets
    {
      /*!
        \class StylePropertyItemListener

        \brief A widget used to define the main property items listener

      */

      class TEQTWIDGETSEXPORT StylePropertyItemListener
      {

      public:
        /** @name Initializer Methods
          *  Methods related to instantiation and destruction.
          */
          //@{

          /*! \brief Constructor */
        StylePropertyItemListener()= default;

        /*! \brief Destructor. */
        virtual ~StylePropertyItemListener() = default;

        //@}

        //!< This function will be called every time a value has changed
        virtual void handleValueChanged(QtProperty* qProperty, const QVariant& qVariant) = 0;
      };
    }
  }
}

#endif //__TERRALIB_QT_WIDGETS_SE_INTERNAL_STYLEPROPERTYITEMLISTENER_H
