/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

// TerraLib
#include "SymbolTreeFilter.h"

// Qt
#include <QtGui/QMouseEvent>
#include <QtGui/QKeyEvent>
#include <QSize>
#include <QIcon>
#include <QPixmap>

// STL
#include <cassert>

te::qt::widgets::SymbolTreeFilter::SymbolTreeFilter(QObject* parent)
  : QObject(parent)
{

}

te::qt::widgets::SymbolTreeFilter::~SymbolTreeFilter()
{
  
}

bool te::qt::widgets::SymbolTreeFilter::eventFilter(QObject* watched, QEvent* e)
{
  switch(e->type())
  {
    case QEvent::DragEnter:
      return drag(static_cast<QDragEnterEvent*>(e));

    case QEvent::Drop:
      return drop(static_cast<QDropEvent*>(e));

    default:
      return QObject::eventFilter(watched, e);
  }
}

bool te::qt::widgets::SymbolTreeFilter::drag(QDragEnterEvent* e)
{
  emit drag();

  return false; // The tree still needs to execute this event
}

bool te::qt::widgets::SymbolTreeFilter::drop(QDropEvent* e)
{
  emit drop();

  return false; // The tree still needs to execute this event
}

