/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/qt/widgets/utils/CoordInfoWidget.h

  \brief ...
*/

#ifndef __TERRALIB_QT_WIDGETS_UTILS_INTERNAL_COORDINFOWIDGET_H
#define __TERRALIB_QT_WIDGETS_UTILS_INTERNAL_COORDINFOWIDGET_H

// TerraLib
#include "../Config.h"

// STL
#include <memory>

// Qt
#include <QWidget>

namespace Ui { class CoordInfoWidgetForm; }

namespace te
{
  namespace qt
  {
    namespace widgets
    {
      class MapDisplay;
      /*!
        \class CoordInfoWidget

        \brief ...
      */
      class TEQTWIDGETSEXPORT CoordInfoWidget : public QWidget
      {
        Q_OBJECT

        public:

          CoordInfoWidget(QWidget* parent = 0, Qt::WindowFlags f = 0);

          ~CoordInfoWidget();

        public:

          void setDisplay(te::qt::widgets::MapDisplay* display);

          void setCoordInfo(double ex, double ny, double llx, double lly);

        protected slots:

          void onDMSToolButtonToggled(bool status);

        protected:

          bool getDisplayCoordMode();

          void setDisplayCoordMode(bool mode);

        private:

          te::qt::widgets::MapDisplay* m_display;

          std::unique_ptr<Ui::CoordInfoWidgetForm> m_ui;
      }; 

    } // end namespace widgets
  }   // end namespace qt
}     // end namespace te

#endif  // __TERRALIB_QT_WIDGETS_UTILS_INTERNAL_COORDINFOWIDGET_H

