/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

 /*!
   \file terralib/qt/widgets/utils/GetValueWidget.cpp

   \brief ...
 */

// TerraLib
#include "GetValueWidget.h"

// Qt
#include <QGridLayout>

te::qt::widgets::GetValueWidget::GetValueWidget(QWidget* parent, Qt::WindowFlags f)
  : QWidget(parent, f)
{
  QGridLayout* layout = new QGridLayout(this);

  m_label = new QLabel("Label", this);

  m_lineEdit = new QLineEdit(this);

  layout->addWidget(m_label, 0, 0);
  layout->addWidget(m_lineEdit, 0, 1);
}

te::qt::widgets::GetValueWidget::~GetValueWidget() = default;

void te::qt::widgets::GetValueWidget::setLabelText(const QString& text)
{
  m_label->setText(text);
}

void te::qt::widgets::GetValueWidget::setValidator(QValidator* validator)
{
  m_lineEdit->setValidator(validator);
}

QString te::qt::widgets::GetValueWidget::getValue()
{
  return m_lineEdit->text();
}