/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

 /*!
   \file terralib/qt/widgets/utils/ProxyAuthenticationHandler.h

   \brief Handle.
 */

#ifndef __TERRALIB_QT_WIDGETS_UTILS_INTERNAL_PROXYAUTHENTICATIONHANDLER_H
#define __TERRALIB_QT_WIDGETS_UTILS_INTERNAL_PROXYAUTHENTICATIONHANDLER_H

 // TerraLib
#include "../Config.h"
#include "../../../core/uri/ProxyAuthenticationHandler.h"

namespace te
{
  namespace qt
  {
    namespace widgets
    {
      /*!
        \class ProxyAuthenticationHandler

        \brief A class to handle the proxy authentication information.

        \ingroup widgets
      */
      class TEQTWIDGETSEXPORT ProxyAuthenticationHandler : public te::core::ProxyAuthenticationHandler
      {

      public:

        ProxyAuthenticationHandler() = default;

        virtual ~ProxyAuthenticationHandler() = default;

        virtual bool getAuthentication(std::string& userName, std::string& password) const;
      };

    } // end namespace widgets
  }   // end namespace qt
}     // end namespace te

#endif  // __TERRALIB_QT_WIDGETS_UTILS_INTERNAL_PROXYAUTHENTICATIONHANDLER_H

