/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

#ifndef __TERRALIB_RP_INTERNAL_BLENDER_TYPE_DEFS_H
#define __TERRALIB_RP_INTERNAL_BLENDER_TYPE_DEFS_H

#include "Config.h"

namespace te
{
  namespace rp
  {
    namespace blender
    {    
      /*! \enum BlendMethod te::rp::Blender class pixel blend methods. */      
      enum BlendMethod 
      {
        InvalidBlendMethod, //!< Invalid blending method.
        NoBlendMethod, //!< No blending performed.
        EuclideanDistanceMethod, //!< Euclidean distance method.
        SumMethod, //!< Pixels will be summed inside the raster overlapped area.
        MaxMethod, //!< Keep the maximum value of two overlapping pixels.
        MinMethod, //!< Keep the minimum value of two overlapping pixels.
        RuleMethod //!< Rule based (this implies in a valid rules pointer given in the initialize method).
      };
    }
  } // end namespace rp
}   // end namespace te

#endif  // __TERRALIB_RP_INTERNAL_BLENDER_TYPE_DEFS_H

