/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/rp/SegmenterStrategy.cpp
  \brief Raster segmenter strategy base class.
*/

#include "SegmenterStrategy.h"

namespace te
{
  namespace rp
  {
    SegmenterStrategy::SegmenterStrategy() = default;

    SegmenterStrategy::~SegmenterStrategy() = default;

    SegmenterStrategy::SegmenterStrategy(const SegmenterStrategy&) = default;

    SegmenterStrategy& SegmenterStrategy::operator=(
        const SegmenterStrategy&) = default;

    void SegmenterStrategy::reset()
    {
      m_errorMessage.clear();
    }

    const std::string& SegmenterStrategy::getErrorMessage() const
    {
      return m_errorMessage;
    }

    void SegmenterStrategy::setErrorMessage( const std::string& newErrorMessage )
    {
      m_errorMessage = newErrorMessage;
    }
  } // end namespace rp
}   // end namespace te    

