#include "MultiSourceClassifierOutputParameters.h"

namespace te
{
	namespace rp
	{
		namespace radar
		{
			MultiSourceClassifierOutputParameters::MultiSourceClassifierOutputParameters() {
				reset();
			}

			MultiSourceClassifierOutputParameters::MultiSourceClassifierOutputParameters(const MultiSourceClassifierOutputParameters& other) {
				reset();
				operator=(other);
			}

			MultiSourceClassifierOutputParameters::~MultiSourceClassifierOutputParameters() {
				reset();
			}

			void MultiSourceClassifierOutputParameters::reset() {
				m_rType.clear();
				m_rInfoClassImage.clear();
				m_outputRasterClassImagePtr.reset();
				newRaster.reset();
				m_rInfoClassImageFuzzy.clear();
				m_outputRasterClassImageFuzzyPtr.reset();
				m_rInfoMap.clear();
				m_outputRasterMapPtr.reset();
				m_rInfoMapPValue.clear();
				m_outputRasterMapPValuePtr.reset();
//				m_rInfoConfusionMatrix.clear();
//				m_rInfoAttributes.clear();
				m_outputRasterBand = 0;
				m_confusionMatrix.clear();
				m_kappaCoefficient = 0.0;
				m_varianceOfKappa = 0.0;
				m_overallAccuracy = 0.0;
				m_IDSegment.clear();
				m_valuesS.clear();
				m_valuesP.clear();
				m_pValuesSum.clear();
				m_pValuesMultiplication.clear();
				m_pValuesMinimum.clear();
				m_distances.clear();
				m_bandsFuzzy.clear();
			}

			const MultiSourceClassifierOutputParameters& MultiSourceClassifierOutputParameters::
				operator=(const MultiSourceClassifierOutputParameters& params) {
				reset();

				m_rType = params.m_rType;
				m_rInfoClassImage = params.m_rInfoClassImage;
				m_rInfoClassImageFuzzy = params.m_rInfoClassImageFuzzy;
				m_rInfoMap = params.m_rInfoMap;
				m_rInfoMapPValue = params.m_rInfoMapPValue;
//				m_rInfoConfusionMatrix = params.m_rInfoConfusionMatrix;
				m_outputRasterBand = params.m_outputRasterBand;
				m_confusionMatrix = params.m_confusionMatrix;
//				m_rInfoAttributes = params.m_rInfoAttributes;
				m_kappaCoefficient = params.m_kappaCoefficient;
				m_varianceOfKappa = params.m_varianceOfKappa;
				m_overallAccuracy = params.m_overallAccuracy;
				m_IDSegment = params.m_IDSegment;
				m_valuesS = params.m_valuesS;
				m_valuesP = params.m_valuesP;
				m_pValuesSum = params.m_pValuesSum;
				m_pValuesMultiplication = params.m_pValuesMultiplication;
				m_pValuesMinimum = params.m_pValuesMinimum;
				m_distances = params.m_distances;
				m_bandsFuzzy = params.m_bandsFuzzy;

				return *this;
			}

			te::common::AbstractParameters* MultiSourceClassifierOutputParameters::clone() const {
				return new MultiSourceClassifierOutputParameters(*this);
			}
		} // end namespace radar
	} // end namespace rp
}   // end namespace msc
