/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file sam.h
  
  \brief This file contains include headers for TerraLib Spatial Access Methods module.
 */
#ifndef __TERRALIB_INTERNAL_SAM_H
#define __TERRALIB_INTERNAL_SAM_H

// TerraLib
#include "sam/kdtree.h"
#include "sam/rtree.h"

namespace te
{
  /*!
    \brief This is the namespace for the TerraLib Spatial Access Methods module.
  
    \note See namespace te comments for any detail on using namespaces.
   */
  namespace sam
  {
  } // end namespace sam
}   // end namespace te

#endif  // __TERRALIB_INTERNAL_SAM_H
