#include "DifferenceDialogCapabilities.h"

#include "../../core/translator/Translator.h"

namespace
{
  static te::vp::qt::DifferenceDialogCapabilitiesFactory
    DifferenceDialogCapabilitiesFactoryInstance;
}

te::vp::qt::DifferenceDialogCapabilities::DifferenceDialogCapabilities()
  : VectorProcessingDialogCapabilities(
      "Difference"
    , TE_TR("Difference")
    , TE_TR("Makes the difference between features of two layers")
    , "vector-processing-difference"
    , "vp-difference-hint"
    , "dpi.inpe.br.plugins"
    , "share/terraview/help/plugins/vp/vp_difference.html"
  )
{

}

te::vp::qt::DifferenceDialogCapabilities::~DifferenceDialogCapabilities() = default;

te::vp::qt::DifferenceDialogCapabilitiesFactory::DifferenceDialogCapabilitiesFactory()
  : VectorProcessingDialogCapabilitiesFactory("Difference")
{

}

te::vp::qt::DifferenceDialogCapabilitiesFactory::~DifferenceDialogCapabilitiesFactory() = default;

te::vp::qt::VectorProcessingDialogCapabilities* te::vp::qt::DifferenceDialogCapabilitiesFactory::build()
{
  return new te::vp::qt::DifferenceDialogCapabilities();
}