#include "IdentityDialogCapabilities.h"

#include "../../core/translator/Translator.h"

namespace
{
  static te::vp::qt::IdentityDialogCapabilitiesFactory
    IdentityDialogCapabilitiesFactoryInstance;
}

te::vp::qt::IdentityDialogCapabilities::IdentityDialogCapabilities()
  : VectorProcessingDialogCapabilities(
      "Identity"
    , TE_TR("Identity")
    , TE_TR("Makes the Identity between features of two layers")
    , "vector-processing-identity"
    , "vp-identity-hint"
    , "dpi.inpe.br.plugins"
    , "share/terraview/help/plugins/vp/vp_identity.html"
  )
{

}

te::vp::qt::IdentityDialogCapabilities::~IdentityDialogCapabilities() = default;

te::vp::qt::IdentityDialogCapabilitiesFactory::IdentityDialogCapabilitiesFactory()
  : VectorProcessingDialogCapabilitiesFactory("Identity")
{

}

te::vp::qt::IdentityDialogCapabilitiesFactory::~IdentityDialogCapabilitiesFactory() = default;

te::vp::qt::VectorProcessingDialogCapabilities* te::vp::qt::IdentityDialogCapabilitiesFactory::build()
{
  return new te::vp::qt::IdentityDialogCapabilities();
}