#include "IntersectionDialogCapabilities.h"

#include "../../core/translator/Translator.h"

namespace
{
  static te::vp::qt::IntersectionDialogCapabilitiesFactory
    IntersectionDialogCapabilitiesFactoryInstance;
}

te::vp::qt::IntersectionDialogCapabilities::IntersectionDialogCapabilities()
  : VectorProcessingDialogCapabilities(
      "Interserction"
    , TE_TR("Intersection")
    , TE_TR("Makes the intersection between features of two layers")
    , "vector-processing-intersection"
    , "vp-intersection-hint"
    , "dpi.inpe.br.plugins"
    , "share/terraview/help/plugins/vp/vp_intersection.html"
  )
{

}

te::vp::qt::IntersectionDialogCapabilities::~IntersectionDialogCapabilities() = default;

te::vp::qt::IntersectionDialogCapabilitiesFactory::IntersectionDialogCapabilitiesFactory()
  : VectorProcessingDialogCapabilitiesFactory("Intersection")
{

}

te::vp::qt::IntersectionDialogCapabilitiesFactory::~IntersectionDialogCapabilitiesFactory() = default;

te::vp::qt::VectorProcessingDialogCapabilities* te::vp::qt::IntersectionDialogCapabilitiesFactory::build()
{
  return new te::vp::qt::IntersectionDialogCapabilities();
}