#include "MakeValidDialogCapabilities.h"

#include "../../core/translator/Translator.h"

namespace
{
  static te::vp::qt::MakeValidDialogCapabilitiesFactory
    MakeValidDialogCapabilitiesFactoryInstance;
}

te::vp::qt::MakeValidDialogCapabilities::MakeValidDialogCapabilities()
  : VectorProcessingDialogCapabilities(
      "MakeValid"
    , TE_TR("Make Layer Valid")
    , TE_TR("Represents an operation to fix features from a input data")
    , "vector-processing-makeValid"
    , "vp-makeValid-hint"
    , "dpi.inpe.br.plugins"
    , "share/terraview/help/plugins/vp/vp_makeValid.html"
  )
{

}

te::vp::qt::MakeValidDialogCapabilities::~MakeValidDialogCapabilities() = default;

te::vp::qt::MakeValidDialogCapabilitiesFactory::MakeValidDialogCapabilitiesFactory()
  : VectorProcessingDialogCapabilitiesFactory("MakeValid")
{

}

te::vp::qt::MakeValidDialogCapabilitiesFactory::~MakeValidDialogCapabilitiesFactory() = default;

te::vp::qt::VectorProcessingDialogCapabilities* te::vp::qt::MakeValidDialogCapabilitiesFactory::build()
{
  return new te::vp::qt::MakeValidDialogCapabilities();
}