#include "SubdivideDialogCapabilities.h"

#include "SpecificParametersWidget.h"
#include "SubdivideParametersWidget.h"

#include "../../core/translator/Translator.h"

namespace
{
  static te::vp::qt::SubdivideDialogCapabilitiesFactory
    SubdivideDialogCapabilitiesFactoryInstance;
}

te::vp::qt::SubdivideDialogCapabilities::SubdivideDialogCapabilities()
  : VectorProcessingDialogCapabilities(
      "Subdivide"
    , TE_TR("Subdivide Geometries")
    , TE_TR("This operation subdivides geometries ensuring that they don't have more than the given number of coordinates")
    , "vp-topology-subDivide"
    , "vp-topology-subDivide-hint"
    , "dpi.inpe.br.plugins"
    , "share/terraview/help/plugins/vp/vp_subdividegeom.html"
  )
{

}

te::vp::qt::SubdivideDialogCapabilities::~SubdivideDialogCapabilities() = default;

te::vp::qt::SpecificParametersWidget* te::vp::qt::SubdivideDialogCapabilities::getParametersWidget(QWidget* parent) const
{
  return new SubdivideParametersWidget(parent);
}

te::vp::qt::SubdivideDialogCapabilitiesFactory::SubdivideDialogCapabilitiesFactory()
  : VectorProcessingDialogCapabilitiesFactory("Subdivide")
{

}

te::vp::qt::SubdivideDialogCapabilitiesFactory::~SubdivideDialogCapabilitiesFactory() = default;

te::vp::qt::VectorProcessingDialogCapabilities* te::vp::qt::SubdivideDialogCapabilitiesFactory::build()
{
  return new te::vp::qt::SubdivideDialogCapabilities();
}