#include "UnionDialogCapabilities.h"

#include "../../core/translator/Translator.h"

namespace
{
  static te::vp::qt::UnionDialogCapabilitiesFactory
    UnionDialogCapabilitiesFactoryInstance;
}

te::vp::qt::UnionDialogCapabilities::UnionDialogCapabilities()
  : VectorProcessingDialogCapabilities(
      "Union"
    , TE_TR("Union")
    , TE_TR("Makes the Union between features of two layers")
    , "vector-processing-union"
    , "vp-union-hint"
    , "dpi.inpe.br.plugins"
    , "share/terraview/help/plugins/vp/vp_union.html"
  )
{

}

te::vp::qt::UnionDialogCapabilities::~UnionDialogCapabilities() = default;

te::vp::qt::UnionDialogCapabilitiesFactory::UnionDialogCapabilitiesFactory()
  : VectorProcessingDialogCapabilitiesFactory("Union")
{

}

te::vp::qt::UnionDialogCapabilitiesFactory::~UnionDialogCapabilitiesFactory() = default;

te::vp::qt::VectorProcessingDialogCapabilities* te::vp::qt::UnionDialogCapabilitiesFactory::build()
{
  return new te::vp::qt::UnionDialogCapabilities();
}