#include "VectorProcessingDialogCapabilities.h"
#include "SpecificParametersWidget.h"

#include "../../qt/widgets/Utils.h"

#include <QIcon>

te::vp::qt::VectorProcessingDialogCapabilities::VectorProcessingDialogCapabilities( 
  const std::string& operationName
, const std::string& caption
, const std::string& description
, const std::string& icon
, const std::string& hintPixmap
, const std::string& helpPageNamespace
, const std::string& helpPageReference
, bool enablePropertySelection
)
  : m_operationName(operationName)
  , m_caption(caption)
  , m_description(description)
  , m_icon(icon)
  , m_hintPixmap(hintPixmap)
  , m_helpPageNamespace(helpPageNamespace)
  , m_helpPageReference(helpPageReference)
  , m_enablePropertySelection(enablePropertySelection)
{
  m_qIcon = QIcon::fromTheme(te::qt::widgets::Convert2QString(m_icon));

  QIcon hintIcon = QIcon::fromTheme(te::qt::widgets::Convert2QString(m_hintPixmap));
  m_qHintPixmap = hintIcon.pixmap(112, 48);
}

te::vp::qt::VectorProcessingDialogCapabilities::~VectorProcessingDialogCapabilities() = default;

const std::string& te::vp::qt::VectorProcessingDialogCapabilities::getName() const
{
  return m_operationName;
}

const std::string& te::vp::qt::VectorProcessingDialogCapabilities::getCaption() const
{
  return m_caption;
}

const std::string& te::vp::qt::VectorProcessingDialogCapabilities::getDescription() const
{
  return m_description;
}

const QIcon& te::vp::qt::VectorProcessingDialogCapabilities::getIcon() const
{
  return m_qIcon;
}

const QPixmap& te::vp::qt::VectorProcessingDialogCapabilities::getHintPixmap() const
{
  return m_qHintPixmap;
}

const std::string& te::vp::qt::VectorProcessingDialogCapabilities::getHelpPageNamespace() const
{
  return m_helpPageNamespace;
}

const std::string& te::vp::qt::VectorProcessingDialogCapabilities::getHelpPageReference() const
{
  return m_helpPageReference;
}

bool te::vp::qt::VectorProcessingDialogCapabilities::isPropertySelectionEnable() const
{
  return m_enablePropertySelection;
}

te::vp::qt::SpecificParametersWidget* te::vp::qt::VectorProcessingDialogCapabilities::getParametersWidget(QWidget* parent) const
{
  return nullptr;
}

te::vp::qt::VectorProcessingDialogCapabilitiesFactory::VectorProcessingDialogCapabilitiesFactory(const std::string& factoryKey)
  : te::common::AbstractFactory < VectorProcessingDialogCapabilities, std::string >(factoryKey)
{

}

te::vp::qt::VectorProcessingDialogCapabilitiesFactory::~VectorProcessingDialogCapabilitiesFactory() = default;
