/*  Copyright (C) 2017 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/ws/ogc/wms/client/1.1.1/WMSXMLParserFactory.cpp

  \brief This is the concrete implementation factory for 1.1.1 WMS XMLParser.
*/

#include "WMSXMLParserFactory.h"

te::ws::ogc::wms::version_1_1_1::WMSXMLParserFactory te::ws::ogc::wms::version_1_1_1::WMSXMLParserFactory::sm_factory;

te::ws::ogc::wms::version_1_1_1::WMSXMLParserFactory::~WMSXMLParserFactory() =
    default;

te::ws::ogc::wms::version_1_1_1::WMSXMLParserFactory::WMSXMLParserFactory()
  : te::ws::ogc::wms::AbstractWMSXMLParserFactory("1.1.1")
{

}

te::ws::ogc::wms::XMLParser* te::ws::ogc::wms::version_1_1_1::WMSXMLParserFactory::build()
{
  return new te::ws::ogc::wms::version_1_1_1::XMLParser;
}
