/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/ws/ogc/wms/Utils.h

  \brief An Utils to be used by WMS dataaccess.
*/

#ifndef __TERRALIB_WS_OGC_UTILS_H
#define __TERRALIB_WS_OGC_UTILS_H

//TerraLib
#include "Config.h"

#include "WMSLayer.h"

#include "../client/DataTypes.h"
#include "../../../../geometry/Envelope.h"
#include "../../../../raster/Raster.h"

namespace te
{
  namespace ws
  {
    namespace ogc
    {
      namespace wms
      {

        TEOGCWMSDATAACCESSEXPORT WMSGetMapResponse GetMap(WMSLayer* wmsLayer, const te::gm::Envelope& box,
                                                          const int& width, const int& height);

        TEOGCWMSDATAACCESSEXPORT te::rst::Raster* GetMapRaster(WMSLayer* wmsLayer, const int& srid, const te::gm::Envelope& box,
                                                               const int& width, const int& height);

        TEOGCWMSDATAACCESSEXPORT te::rst::Raster* GetLayerMapRaster(const WMSLayer* wmsLayer);
      }
    }
  }
}

#endif
