/*  Copyright (C) 2017 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/ws/ogc/wms/qt/WMSGetFeatureInfoMakerFactory.cpp

  \brief WMSGetFeatureInfoMakerFactory is an implementation of a factory to make
         WMSGetFeatureInfoMaker objects.
*/

#include "WMSGetFeatureInfoMakerFactory.h"
#include "WMSGetFeatureInfoMaker.h"

#include "../../../../qt/widgets/layer/info/AbstractFeatureInfoMaker.h"

te::ws::ogc::wms::qt::WMSGetFeatureInfoMakerFactory te::ws::ogc::wms::qt::WMSGetFeatureInfoMakerFactory::sm_factory;

te::ws::ogc::wms::qt::WMSGetFeatureInfoMakerFactory::
    ~WMSGetFeatureInfoMakerFactory() = default;

te::ws::ogc::wms::qt::WMSGetFeatureInfoMakerFactory::WMSGetFeatureInfoMakerFactory()
  : FeatureInfoMakerFactory("OGCWMSLAYER")
{

}

te::qt::widgets::AbstractFeatureInfoMaker* te::ws::ogc::wms::qt::WMSGetFeatureInfoMakerFactory::build()
{
  return new WMSGetFeatureInfoMaker();
}
