/*  Copyright (C) 2017 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

#ifndef __TERRALIB_WS_OGC_WMS_QT_WMSGETFEATUREINFOMAKERFACTORY_H
#define __TERRALIB_WS_OGC_WMS_QT_WMSGETFEATUREINFOMAKERFACTORY_H

/*!
  \file terralib/ws/ogc/wms/qt/WMSGetFeatureInfoMakerFactory.h

  \brief WMSGetFeatureInfoMakerFactory is an implementation of a factory to make
         WMSGetFeatureInfoMaker objects.
*/

#include "Config.h"

#include "../../../../qt/widgets/layer/info/FeatureInfoMakerFactory.h"

namespace te
{
  namespace qt
  {
    namespace widgets
    {
      class AbstractFeatureInfoMaker;
    }
  }

  namespace ws
  {
    namespace ogc
    {
      namespace wms
      {
        namespace qt
        {

        class TEOGCWMSQTEXPORT WMSGetFeatureInfoMakerFactory : public te::qt::widgets::FeatureInfoMakerFactory
        {

        public:


          /*! \brief Destructor. */
          virtual ~WMSGetFeatureInfoMakerFactory();

        protected:

          /*! \brief Default constructor. */
          WMSGetFeatureInfoMakerFactory();

          /*! \brief Builds a new  DefaultFeatureInfoMaker object. */
          te::qt::widgets::AbstractFeatureInfoMaker* build();

        private:

          static WMSGetFeatureInfoMakerFactory sm_factory; //!< Static attribute used to register this factory
        };

        }
      }
    }
  }
}

#endif // __TERRALIB_WS_OGC_WMS_QT_WMSGETFEATUREINFOMAKER_H
