#include "WMSItemDelegate.h"

//TerraLib
#include "../../../../qt/widgets/layer/explorer/LayerItem.h"

te::ws::ogc::wms::qt::WMSItemDelegate::WMSItemDelegate(QStyledItemDelegate *decorated, QObject *parent)
  : te::common::Decorator<QStyledItemDelegate>(decorated, false)
{
  setParent(parent);

  m_icon = QIcon::fromTheme("datasource-wms");
}

te::ws::ogc::wms::qt::WMSItemDelegate::~WMSItemDelegate() = default;

void te::ws::ogc::wms::qt::WMSItemDelegate::paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
  te::qt::widgets::TreeItem* item = static_cast<te::qt::widgets::TreeItem*>(index.internalPointer());

  if(item->getType() == "LAYER")
  {
    te::qt::widgets::LayerItem* li = (te::qt::widgets::LayerItem*)item;

    if(li->getLayer()->getType() == "OGCWMSLAYER" && li->getLayer()->getLastValidatedValue() == true)
    {
#if (QT_VERSION >= QT_VERSION_CHECK(5, 0, 0))
      QStyleOptionViewItem opt(option);
      opt.features |= QStyleOptionViewItem::HasDecoration;
#else
      QStyleOptionViewItemV4 opt(option);
      opt.features |= QStyleOptionViewItemV4::HasDecoration;
#endif

      opt.decorationSize = QSize(20, 20);
      opt.icon = m_icon;

      QStyledItemDelegate::paint(painter, opt, index);

      return;
    }
  }

  if(m_decorated != nullptr)
    m_decorated->paint(painter, option, index);
  else
    QStyledItemDelegate::paint(painter, option, index);
}
