#include "TerraViewApp.h"
#include <exception>
#include <iostream>

#include <QMessageBox>

TerraViewApp::TerraViewApp(int& argc, char** argv) :
  QApplication(argc, argv)
{
}

bool TerraViewApp::notify(QObject* receiver, QEvent* event)
{
  bool done = true;

  try
  {
    done = QApplication::notify(receiver, event);
  }
  catch (const std::exception& ex)
  {
    QMessageBox::warning(0, tr("TerraView"), QString(ex.what()));

    std::cout << std::endl << "Exception catched: " << ex.what() << std::endl;
  }
  catch (...)
  {
    QMessageBox::warning(0, tr("TerraView"), "Unknown Error.");

    std::cout << "Unknown exception catched\n";
  }
  
  return done;
}
