/*  Copyright (C) 2008 National Institute For Space Research (INPE) - Brazil.

    This file is part of the TerraLib - a Framework for building GIS enabled applications.

    TerraLib is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    TerraLib is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with TerraLib. See COPYING. If not, write to
    TerraLib Team at <terralib-team@terralib.org>.
 */

/*!
  \file terralib/unittest/core/utils/TsPlatform.cpp

  \brief A test suite for the TerraLib Core Utils Module.

  \author Carolina Galvão dos Santos
 */

// STL
#include <string>

// TerraLib
#include <terralib/core/utils/Platform.h>
#include <terralib/core/utils/Utils.h>

// Boost
#include <boost/test/unit_test.hpp>
#include <boost/algorithm/string/predicate.hpp>

BOOST_AUTO_TEST_SUITE( base64_tests )

BOOST_AUTO_TEST_CASE( base64_encoder )
{

  BOOST_CHECK_NO_THROW(te::core::encodeBase64("testing_base64")=="dGVzdGluZ19iYXNlNjQ=");

  return;
}

BOOST_AUTO_TEST_CASE( base64_decoder )
{

  BOOST_CHECK_NO_THROW(te::core::decodeBase64("dGVzdGluZ19iYXNlNjQ=")=="testing_base64");

  return;
}

BOOST_AUTO_TEST_SUITE_END()
